Whamcloud - gitweb
LU-2934 lnet: Add LNet Router Priority parameter
[fs/lustre-release.git] / lustre / tests / sanity.sh
index 1fed554..fcf5f72 100644 (file)
@@ -139,165 +139,113 @@ echo # add a newline after mke2fs.
 
 umask 077
 
-OLDDEBUG="`lctl get_param -n debug 2> /dev/null`"
+OLDDEBUG=$(lctl get_param -n debug 2> /dev/null)
 lctl set_param debug=-1 2> /dev/null || true
-test_0() {
+test_0a() {
        touch $DIR/$tfile
-       $CHECKSTAT -t file $DIR/$tfile || error
+       $CHECKSTAT -t file $DIR/$tfile || error "$tfile is not a file"
        rm $DIR/$tfile
-       $CHECKSTAT -a $DIR/$tfile || error
+       $CHECKSTAT -a $DIR/$tfile || error "$tfile was not removed"
 }
-run_test 0 "touch .../$tfile ; rm .../$tfile ====================="
+run_test 0a "touch; rm ====================="
 
 test_0b() {
-       chmod 0755 $DIR || error
-       $CHECKSTAT -p 0755 $DIR || error
+       chmod 0755 $DIR || error "chmod 0755 $DIR failed"
+       $CHECKSTAT -p 0755 $DIR || error "$DIR permission is not 0755"
 }
 run_test 0b "chmod 0755 $DIR ============================="
 
 test_0c() {
-    $LCTL get_param mdc.*.import | grep  "state: FULL" || error "import not FULL"
-    $LCTL get_param mdc.*.import | grep  "target: $FSNAME-MDT" || error "bad target"
+       $LCTL get_param mdc.*.import | grep "state: FULL" ||
+               error "import not FULL"
+       $LCTL get_param mdc.*.import | grep "target: $FSNAME-MDT" ||
+               error "bad target"
 }
 run_test 0c "check import proc ============================="
 
-test_1a() {
-       test_mkdir -p $DIR/$tdir
-       test_mkdir -p $DIR/$tdir/d2
+test_1() {
+       test_mkdir -p $DIR/$tdir || error "mkdir $tdir failed"
+       test_mkdir -p $DIR/$tdir/d2 || error "mkdir $tdir/d2 failed"
        test_mkdir $DIR/$tdir/d2 && error "we expect EEXIST, but not returned"
-       $CHECKSTAT -t dir $DIR/$tdir/d2 || error
-}
-run_test 1a "mkdir .../d1; mkdir .../d1/d2 ====================="
-
-test_1b() {
+       $CHECKSTAT -t dir $DIR/$tdir/d2 || error "$tdir/d2 is not a dir"
        rmdir $DIR/$tdir/d2
        rmdir $DIR/$tdir
-       $CHECKSTAT -a $DIR/$tdir || error
+       $CHECKSTAT -a $DIR/$tdir || error "$tdir was not removed"
 }
-run_test 1b "rmdir .../d1/d2; rmdir .../d1 ====================="
+run_test 1 "mkdir; remkdir; rmdir =============================="
 
-test_2a() {
-       test_mkdir $DIR/$tdir
-       touch $DIR/$tdir/$tfile
-       $CHECKSTAT -t file $DIR/$tdir/$tfile || error
-}
-run_test 2a "mkdir .../d2; touch .../d2/f ======================"
-
-test_2b() {
+test_2() {
+       test_mkdir -p $DIR/$tdir || error "mkdir $tdir failed"
+       touch $DIR/$tdir/$tfile || error "touch $tdir/$tfile failed"
+       $CHECKSTAT -t file $DIR/$tdir/$tfile || error "$tdir/$tfile not a file"
        rm -r $DIR/$tdir
-       $CHECKSTAT -a $DIR/$tdir || error
-}
-run_test 2b "rm -r .../d2; checkstat .../d2/f ======================"
-
-test_3a() {
-       test_mkdir -p $DIR/$tdir
-       $CHECKSTAT -t dir $DIR/$tdir || error
+       $CHECKSTAT -a $DIR/$tdir/$tfile || error "$tdir/$file is not removed"
 }
-run_test 3a "mkdir .../d3 ======================================"
+run_test 2 "mkdir; touch; rmdir; check file ===================="
 
-test_3b() {
-       if [ ! -d $DIR/$tdir ]; then
-               mkdir $DIR/$tdir
-       fi
+test_3() {
+       test_mkdir -p $DIR/$tdir || error "mkdir $tdir failed"
+       $CHECKSTAT -t dir $DIR/$tdir || error "$tdir is not a directory"
        touch $DIR/$tdir/$tfile
-       $CHECKSTAT -t file $DIR/$tdir/$tfile || error
-}
-run_test 3b "touch .../d3/f ===================================="
-
-test_3c() {
+       $CHECKSTAT -t file $DIR/$tdir/$tfile || error "$tdir/$tfile not a file"
        rm -r $DIR/$tdir
-       $CHECKSTAT -a $DIR/$tdir || error
-}
-run_test 3c "rm -r .../d3 ======================================"
-
-test_4a() {
-       test_mkdir -p $DIR/$tdir
-       $CHECKSTAT -t dir $DIR/$tdir || error
+       $CHECKSTAT -a $DIR/$tdir || error "$tdir is not removed"
 }
-run_test 4a "mkdir .../d4 ======================================"
-
-test_4b() {
-       if [ ! -d $DIR/$tdir ]; then
-               test_mkdir $DIR/$tdir
-       fi
-       test_mkdir $DIR/$tdir/d2
-       mkdir $DIR/$tdir/d2
-       $CHECKSTAT -t dir $DIR/$tdir/d2 || error
-}
-run_test 4b "mkdir .../d4/d2 ==================================="
+run_test 3 "mkdir; touch; rmdir; check dir ====================="
 
 test_5() {
-       test_mkdir $DIR/$tdir
-       test_mkdir $DIR/$tdir/d2
-       chmod 0707 $DIR/$tdir/d2
-       $CHECKSTAT -t dir -p 0707 $DIR/$tdir/d2 || error
+       test_mkdir -p $DIR/$tdir || error "mkdir $tdir failed"
+       test_mkdir $DIR/$tdir/d2 || error "mkdir $tdir/d2 failed"
+       chmod 0707 $DIR/$tdir/d2 || error "chmod 0707 $tdir/d2 failed"
+       $CHECKSTAT -t dir -p 0707 $DIR/$tdir/d2 || error "$tdir/d2 not mode 707"
+       $CHECKSTAT -t dir $DIR/$tdir/d2 || error "$tdir/d2 is not a directory"
 }
 run_test 5 "mkdir .../d5 .../d5/d2; chmod .../d5/d2 ============"
 
 test_6a() {
-       touch $DIR/$tfile
-       chmod 0666 $DIR/$tfile || error
-       $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/$tfile || error
+       touch $DIR/$tfile || error "touch $DIR/$tfile failed"
+       chmod 0666 $DIR/$tfile || error "chmod 0666 $tfile failed"
+       $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/$tfile ||
+               error "$tfile does not have perm 0666 or UID $UID"
+       $RUNAS chmod 0444 $DIR/$tfile && error "chmod $tfile worked on UID $UID"
+       $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/$tfile ||
+               error "$tfile should be 0666 and owned by UID $UID"
 }
-run_test 6a "touch .../f6a; chmod .../f6a ======================"
-
-test_6b() {
-       [ $RUNAS_ID -eq $UID ] && skip_env "RUNAS_ID = UID = $UID" && return
-       if [ ! -f $DIR/$tfile ]; then
-               touch $DIR/$tfile
-               chmod 0666 $DIR/$tfile
-       fi
-       $RUNAS chmod 0444 $DIR/$tfile && error
-       $CHECKSTAT -t file -p 0666 -u \#$UID $DIR/$tfile || error
-}
-run_test 6b "$RUNAS chmod .../f6a (should return error) =="
+run_test 6a "touch f6a; chmod f6a; $RUNAS chmod f6a (should return error) =="
 
 test_6c() {
        [ $RUNAS_ID -eq $UID ] && skip_env "RUNAS_ID = UID = $UID" && return
        touch $DIR/$tfile
-       chown $RUNAS_ID $DIR/$tfile || error
-       $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/$tfile || error
-}
-run_test 6c "touch .../f6c; chown .../f6c ======================"
-
-test_6d() {
-       [ $RUNAS_ID -eq $UID ] && skip_env "RUNAS_ID = UID = $UID" && return
-       if [ ! -f $DIR/$tfile ]; then
-               touch $DIR/$tfile
-               chown $RUNAS_ID $DIR/$tfile
-       fi
-       $RUNAS chown $UID $DIR/$tfile && error
-       $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/$tfile || error
+       chown $RUNAS_ID $DIR/$tfile || error "chown $RUNAS_ID $file failed"
+       $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/$tfile ||
+               error "$tfile should be owned by UID $RUNAS_ID"
+       $RUNAS chown $UID $DIR/$tfile && error "chown $UID $file succeeded"
+       $CHECKSTAT -t file -u \#$RUNAS_ID $DIR/$tfile ||
+               error "$tfile should be owned by UID $RUNAS_ID"
 }
-run_test 6d "$RUNAS chown .../f6c (should return error) =="
+run_test 6c "touch f6c; chown f6c; $RUNAS chown f6c (should return error) =="
 
 test_6e() {
        [ $RUNAS_ID -eq $UID ] && skip_env "RUNAS_ID = UID = $UID" && return
        touch $DIR/$tfile
-       chgrp $RUNAS_ID $DIR/$tfile || error
-       $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/$tfile || error
+       chgrp $RUNAS_ID $DIR/$tfile || error "chgrp $RUNAS_ID $file failed"
+       $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/$tfile ||
+               error "$tfile should be owned by GID $UID"
+       $RUNAS chgrp $UID $DIR/$tfile && error "chgrp $UID $file succeeded"
+       $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/$tfile ||
+               error "$tfile should be owned by UID $UID and GID $RUNAS_ID"
 }
-run_test 6e "touch .../f6e; chgrp .../f6e ======================"
-
-test_6f() {
-       [ $RUNAS_ID -eq $UID ] && skip_env "RUNAS_ID = UID = $UID" && return
-       if [ ! -f $DIR/$tfile ]; then
-               touch $DIR/$tfile
-               chgrp $RUNAS_ID $DIR/$tfile
-       fi
-       $RUNAS chgrp $UID $DIR/$tfile && error
-       $CHECKSTAT -t file -u \#$UID -g \#$RUNAS_ID $DIR/$tfile || error
-}
-run_test 6f "$RUNAS chgrp .../f6e (should return error) =="
+run_test 6e "touch f6e; chgrp f6e; $RUNAS chgrp f6e (should return error) =="
 
 test_6g() {
        [ $RUNAS_ID -eq $UID ] && skip_env "RUNAS_ID = UID = $UID" && return
-       test_mkdir $DIR/$tdir || error
-        chmod 777 $DIR/$tdir || error
-        $RUNAS mkdir $DIR/$tdir/d || error
-        chmod g+s $DIR/$tdir/d || error
-        test_mkdir $DIR/$tdir/d/subdir
-       $CHECKSTAT -g \#$RUNAS_GID $DIR/$tdir/d/subdir || error
+       test_mkdir $DIR/$tdir || error "mkdir $tfile failed"
+       chmod 777 $DIR/$tdir || error "chmod 0777 $tdir failed"
+       $RUNAS mkdir $DIR/$tdir/d || error "mkdir $tdir/d failed"
+       chmod g+s $DIR/$tdir/d || error "chmod g+s $tdir/d failed"
+       test_mkdir $DIR/$tdir/d/subdir || error "mkdir $tdir/d/subdir failed"
+       $CHECKSTAT -g \#$RUNAS_GID $DIR/$tdir/d/subdir ||
+               error "$tdir/d/subdir should be GID $RUNAS_GID"
 }
 run_test 6g "Is new dir in sgid dir inheriting group?"
 
@@ -306,8 +254,9 @@ test_6h() { # bug 7331
        touch $DIR/$tfile || error "touch failed"
        chown $RUNAS_ID:$RUNAS_GID $DIR/$tfile || error "initial chown failed"
        $RUNAS -G$RUNAS_GID chown $RUNAS_ID:0 $DIR/$tfile &&
-               error "chown worked"
-       $CHECKSTAT -t file -u \#$RUNAS_ID -g \#$RUNAS_GID $DIR/$tfile || error
+               error "chown $RUNAS_ID:0 $tfile worked as GID $RUNAS_GID"
+       $CHECKSTAT -t file -u \#$RUNAS_ID -g \#$RUNAS_GID $DIR/$tfile ||
+               error "$tdir/$tfile should be UID $RUNAS_UID GID $RUNAS_GID"
 }
 run_test 6h "$RUNAS chown RUNAS_ID.0 .../f6h (should return error)"
 
@@ -315,7 +264,8 @@ test_7a() {
        test_mkdir $DIR/$tdir
        $MCREATE $DIR/$tdir/$tfile
        chmod 0666 $DIR/$tdir/$tfile
-       $CHECKSTAT -t file -p 0666 $DIR/$tdir/$tfile || error
+       $CHECKSTAT -t file -p 0666 $DIR/$tdir/$tfile ||
+               error "$tdir/$tfile should be mode 0666"
 }
 run_test 7a "mkdir .../d7; mcreate .../d7/f; chmod .../d7/f ===="
 
@@ -325,8 +275,8 @@ test_7b() {
        fi
        $MCREATE $DIR/$tdir/$tfile
        echo -n foo > $DIR/$tdir/$tfile
-       [ "`cat $DIR/$tdir/$tfile`" = "foo" ] || error
-       $CHECKSTAT -t file -s 3 $DIR/$tdir/$tfile || error
+       [ "$(cat $DIR/$tdir/$tfile)" = "foo" ] || error "$tdir/$tfile not 'foo'"
+       $CHECKSTAT -t file -s 3 $DIR/$tdir/$tfile || error "$tfile size not 3"
 }
 run_test 7b "mkdir .../d7; mcreate d7/f2; echo foo > d7/f2 ====="
 
@@ -334,7 +284,8 @@ test_8() {
        test_mkdir $DIR/$tdir
        touch $DIR/$tdir/$tfile
        chmod 0666 $DIR/$tdir/$tfile
-       $CHECKSTAT -t file -p 0666 $DIR/$tdir/$tfile || error
+       $CHECKSTAT -t file -p 0666 $DIR/$tdir/$tfile ||
+               error "$tfile mode not 0666"
 }
 run_test 8 "mkdir .../d8; touch .../d8/f; chmod .../d8/f ======="
 
@@ -342,7 +293,7 @@ test_9() {
        test_mkdir $DIR/$tdir
        test_mkdir $DIR/$tdir/d2
        test_mkdir $DIR/$tdir/d2/d3
-       $CHECKSTAT -t dir $DIR/$tdir/d2/d3 || error
+       $CHECKSTAT -t dir $DIR/$tdir/d2/d3 || error "$tdir/d2/d3 not a dir"
 }
 run_test 9 "mkdir .../d9 .../d9/d2 .../d9/d2/d3 ================"
 
@@ -350,7 +301,8 @@ test_10() {
        test_mkdir $DIR/$tdir
        test_mkdir $DIR/$tdir/d2
        touch $DIR/$tdir/d2/$tfile
-       $CHECKSTAT -t file $DIR/$tdir/d2/$tfile || error
+       $CHECKSTAT -t file $DIR/$tdir/d2/$tfile ||
+               error "$tdir/d2/$tfile not a file"
 }
 run_test 10 "mkdir .../d10 .../d10/d2; touch .../d10/d2/f ======"
 
@@ -359,7 +311,8 @@ test_11() {
        test_mkdir $DIR/$tdir/d2
        chmod 0666 $DIR/$tdir/d2
        chmod 0705 $DIR/$tdir/d2
-       $CHECKSTAT -t dir -p 0705 $DIR/$tdir/d2 || error
+       $CHECKSTAT -t dir -p 0705 $DIR/$tdir/d2 ||
+               error "$tdir/d2 mode not 0705"
 }
 run_test 11 "mkdir .../d11 d11/d2; chmod .../d11/d2 ============"
 
@@ -368,7 +321,8 @@ test_12() {
        touch $DIR/$tdir/$tfile
        chmod 0666 $DIR/$tdir/$tfile
        chmod 0654 $DIR/$tdir/$tfile
-       $CHECKSTAT -t file -p 0654 $DIR/$tdir/$tfile || error
+       $CHECKSTAT -t file -p 0654 $DIR/$tdir/$tfile ||
+               error "$tdir/d2 mode not 0654"
 }
 run_test 12 "touch .../d12/f; chmod .../d12/f .../d12/f ========"
 
@@ -376,7 +330,8 @@ test_13() {
        test_mkdir $DIR/$tdir
        dd if=/dev/zero of=$DIR/$tdir/$tfile count=10
        >  $DIR/$tdir/$tfile
-       $CHECKSTAT -t file -s 0 $DIR/$tdir/$tfile || error
+       $CHECKSTAT -t file -s 0 $DIR/$tdir/$tfile ||
+               error "$tdir/$tfile size not 0 after truncate"
 }
 run_test 13 "creat .../d13/f; dd .../d13/f; > .../d13/f ========"
 
@@ -384,7 +339,7 @@ test_14() {
        test_mkdir $DIR/$tdir
        touch $DIR/$tdir/$tfile
        rm $DIR/$tdir/$tfile
-       $CHECKSTAT -a $DIR/$tdir/$tfile || error
+       $CHECKSTAT -a $DIR/$tdir/$tfile || error "$tdir/$tfile not removed"
 }
 run_test 14 "touch .../d14/f; rm .../d14/f; rm .../d14/f ======="
 
@@ -392,7 +347,8 @@ test_15() {
        test_mkdir $DIR/$tdir
        touch $DIR/$tdir/$tfile
        mv $DIR/$tdir/$tfile $DIR/$tdir/${tfile}_2
-       $CHECKSTAT -t file $DIR/$tdir/${tfile}_2 || error
+       $CHECKSTAT -t file $DIR/$tdir/${tfile}_2 ||
+               error "$tdir/${tfile_2} not a file after rename"
 }
 run_test 15 "touch .../d15/f; mv .../d15/f .../d15/f2 =========="
 
@@ -400,7 +356,7 @@ test_16() {
        test_mkdir $DIR/$tdir
        touch $DIR/$tdir/$tfile
        rm -rf $DIR/$tdir/$tfile
-       $CHECKSTAT -a $DIR/$tdir/$tfile || error
+       $CHECKSTAT -a $DIR/$tdir/$tfile || error "$tdir/$tfile not removed"
 }
 run_test 16 "touch .../d16/f; rm -rf .../d16/f ================="
 
@@ -409,10 +365,12 @@ test_17a() {
        touch $DIR/$tdir/$tfile
        ln -s $DIR/$tdir/$tfile $DIR/$tdir/l-exist
        ls -l $DIR/$tdir
-       $CHECKSTAT -l $DIR/$tdir/$tfile $DIR/$tdir/l-exist || error
-       $CHECKSTAT -f -t f $DIR/$tdir/l-exist || error
+       $CHECKSTAT -l $DIR/$tdir/$tfile $DIR/$tdir/l-exist ||
+               error "$tdir/l-exist not a symlink"
+       $CHECKSTAT -f -t f $DIR/$tdir/l-exist ||
+               error "$tdir/l-exist not referencing a file"
        rm -f $DIR/$tdir/l-exist
-       $CHECKSTAT -a $DIR/$tdir/l-exist || error
+       $CHECKSTAT -a $DIR/$tdir/l-exist || error "$tdir/l-exist not removed"
 }
 run_test 17a "symlinks: create, remove (real) =================="
 
@@ -420,10 +378,12 @@ test_17b() {
        test_mkdir -p $DIR/$tdir
        ln -s no-such-file $DIR/$tdir/l-dangle
        ls -l $DIR/$tdir
-       $CHECKSTAT -l no-such-file $DIR/$tdir/l-dangle || error
-       $CHECKSTAT -fa $DIR/$tdir/l-dangle || error
+       $CHECKSTAT -l no-such-file $DIR/$tdir/l-dangle ||
+               error "$tdir/l-dangle not referencing no-such-file"
+       $CHECKSTAT -fa $DIR/$tdir/l-dangle ||
+               error "$tdir/l-dangle not referencing non-existent file"
        rm -f $DIR/$tdir/l-dangle
-       $CHECKSTAT -a $DIR/$tdir/l-dangle || error
+       $CHECKSTAT -a $DIR/$tdir/l-dangle || error "$tdir/l-dangle not removed"
 }
 run_test 17b "symlinks: create, remove (dangling) =============="
 
@@ -677,6 +637,33 @@ test_17n() {
 }
 run_test 17n "run e2fsck against master/slave MDT which contains remote dir"
 
+test_17o() {
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.3.64) ]] &&
+               skip "Need MDS version at least 2.3.64" && return
+
+       local WDIR=$DIR/${tdir}o
+       local mdt_index
+       local mdtdevname
+       local rc=0
+
+       mkdir -p $WDIR
+       mdt_index=$($LFS getstripe -M $WDIR)
+       mdt_index=$((mdt_index+1))
+       mdtdevname=$(mdsdevname $mdt_index)
+
+       touch $WDIR/$tfile
+       stop mds${mdt_index}
+       start mds${mdt_index} $mdtdevname $MDS_MOUNT_OPTS
+
+       #define OBD_FAIL_OSD_LMA_INCOMPAT 0x194
+       do_facet mds${mdt_index} lctl set_param fail_loc=0x194
+       ls -l $WDIR/$tfile && rc=1
+       do_facet mds${mdt_index} lctl set_param fail_loc=0
+       [[ $rc -ne 0 ]] && error "stat file should fail"
+       true
+}
+run_test 17o "stat file with incompat LMA feature"
+
 test_18() {
        touch $DIR/f || error "Failed to touch $DIR/f: $?"
        ls $DIR || error "Failed to ls $DIR: $?"
@@ -684,21 +671,22 @@ test_18() {
 run_test 18 "touch .../f ; ls ... =============================="
 
 test_19a() {
-       touch $DIR/f19
+       touch $DIR/$tfile
        ls -l $DIR
-       rm $DIR/f19
-       $CHECKSTAT -a $DIR/f19 || error
+       rm $DIR/$tfile
+       $CHECKSTAT -a $DIR/$tfile || error "$tfile was not removed"
 }
 run_test 19a "touch .../f19 ; ls -l ... ; rm .../f19 ==========="
 
 test_19b() {
-       ls -l $DIR/f19 && error || true
+       ls -l $DIR/$tfile && error "ls -l $tfile failed"|| true
 }
 run_test 19b "ls -l .../f19 (should return error) =============="
 
 test_19c() {
-       [ $RUNAS_ID -eq $UID ] && skip_env "RUNAS_ID = UID = $UID -- skipping" && return
-       $RUNAS touch $DIR/f19 && error || true
+       [ $RUNAS_ID -eq $UID ] &&
+               skip_env "RUNAS_ID = UID = $UID -- skipping" && return
+       $RUNAS touch $DIR/$tfile && error "create non-root file failed" || true
 }
 run_test 19c "$RUNAS touch .../f19 (should return error) =="
 
@@ -708,27 +696,28 @@ test_19d() {
 run_test 19d "cat .../f19 (should return error) =============="
 
 test_20() {
-       touch $DIR/f
-       rm $DIR/f
+       touch $DIR/$tfile
+       rm $DIR/$tfile
        log "1 done"
-       touch $DIR/f
-       rm $DIR/f
+       touch $DIR/$tfile
+       rm $DIR/$tfile
        log "2 done"
-       touch $DIR/f
-       rm $DIR/f
+       touch $DIR/$tfile
+       rm $DIR/$tfile
        log "3 done"
-       $CHECKSTAT -a $DIR/f || error
+       $CHECKSTAT -a $DIR/$tfile || error "$tfile was not removed"
 }
 run_test 20 "touch .../f ; ls -l ... ==========================="
 
 test_21() {
-       test_mkdir $DIR/d21
-       [ -f $DIR/d21/dangle ] && rm -f $DIR/d21/dangle
-       ln -s dangle $DIR/d21/link
-       echo foo >> $DIR/d21/link
-       cat $DIR/d21/dangle
-       $CHECKSTAT -t link $DIR/d21/link || error
-       $CHECKSTAT -f -t file $DIR/d21/link || error
+       test_mkdir -p $DIR/$tdir
+       [ -f $DIR/$tdir/dangle ] && rm -f $DIR/$tdir/dangle
+       ln -s dangle $DIR/$tdir/link
+       echo foo >> $DIR/$tdir/link
+       cat $DIR/$tdir/dangle
+       $CHECKSTAT -t link $DIR/$tdir/link || error "$tdir/link not a link"
+       $CHECKSTAT -f -t file $DIR/$tdir/link ||
+               error "$tdir/link not linked to a file"
 }
 run_test 21 "write to dangling link ============================"
 
@@ -768,43 +757,43 @@ test_23b() { # bug 18988
 }
 run_test 23b "O_APPEND check =========================="
 
+# rename sanity
 test_24a() {
-       echo '== rename sanity =============================================='
        echo '-- same directory rename'
-       test_mkdir $DIR/R1
-       touch $DIR/R1/f
-       mv $DIR/R1/f $DIR/R1/g
-       $CHECKSTAT -t file $DIR/R1/g || error
+       test_mkdir $DIR/$tdir
+       touch $DIR/$tdir/$tfile.1
+       mv $DIR/$tdir/$tfile.1 $DIR/$tdir/$tfile.2
+       $CHECKSTAT -t file $DIR/$tdir/$tfile.2 || error "$tfile.2 not a file"
 }
-run_test 24a "touch .../R1/f; rename .../R1/f .../R1/g ========="
+run_test 24a "rename file to non-existent target"
 
 test_24b() {
-       test_mkdir $DIR/R2
-       touch $DIR/R2/{f,g}
-       mv $DIR/R2/f $DIR/R2/g
-       $CHECKSTAT -a $DIR/R2/f || error
-       $CHECKSTAT -t file $DIR/R2/g || error
+       test_mkdir $DIR/$tdir
+       touch $DIR/$tdir/$tfile.{1,2}
+       mv $DIR/$tdir/$tfile.1 $DIR/$tdir/$tfile.2
+       $CHECKSTAT -a $DIR/$tdir/$tfile.1 || error "$tfile.1 exists"
+       $CHECKSTAT -t file $DIR/$tdir/$tfile.2 || error "$tfile.2 not a file"
 }
-run_test 24b "touch .../R2/{f,g}; rename .../R2/f .../R2/g ====="
+run_test 24b "rename file to existing target"
 
 test_24c() {
-       test_mkdir $DIR/R3
-       test_mkdir $DIR/R3/f
-       mv $DIR/R3/f $DIR/R3/g
-       $CHECKSTAT -a $DIR/R3/f || error
-       $CHECKSTAT -t dir $DIR/R3/g || error
+       test_mkdir $DIR/$tdir
+       test_mkdir $DIR/$tdir/d$testnum.1
+       mv $DIR/$tdir/d$testnum.1 $DIR/$tdir/d$testnum.2
+       $CHECKSTAT -a $DIR/$tdir/d$testnum.1 || error "d$testnum.1 exists"
+       $CHECKSTAT -t dir $DIR/$tdir/d$testnum.2 || error "d$testnum.2 not dir"
 }
-run_test 24c "mkdir .../R3/f; rename .../R3/f .../R3/g ========="
+run_test 24c "rename directory to non-existent target"
 
 test_24d() {
-       test_mkdir $DIR/R4
-       test_mkdir $DIR/R4/f
-       test_mkdir $DIR/R4/g
-       mrename $DIR/R4/f $DIR/R4/g
-       $CHECKSTAT -a $DIR/R4/f || error
-       $CHECKSTAT -t dir $DIR/R4/g || error
+       test_mkdir $DIR/$tdir
+       test_mkdir $DIR/$tdir/d$testnum.1
+       test_mkdir $DIR/$tdir/d$ttestnum.2
+       mrename $DIR/$tdir/d$testnum.1 $DIR/$tdir/d$testnum.2
+       $CHECKSTAT -a $DIR/$tdir/d$testnum.1 || error "d$testnum.1 exists"
+       $CHECKSTAT -t dir $DIR/$tdir/d$testnum.2 || error "d$testnum.2 not dir"
 }
-run_test 24d "mkdir .../R4/{f,g}; rename .../R4/f .../R4/g ====="
+run_test 24d "rename directory to existing target"
 
 test_24e() {
        echo '-- cross directory renames --'
@@ -1128,6 +1117,21 @@ test_24z() {
 }
 run_test 24z "rename one remote dir to another remote dir should fail"
 
+test_24A() { # LU-3182
+       local NFILES=5000
+
+       mkdir -p $DIR/$tdir
+       createmany -m $DIR/$tdir/$tfile $NFILES
+       local t=`ls $DIR/$tdir | wc -l`
+       local u=`ls $DIR/$tdir | sort -u | wc -l`
+       if [ $t -ne $NFILES -o $u -ne $NFILES ] ; then
+               error "Expected $NFILES files, got $t ($u unique)"
+       fi
+
+       rm -rf $DIR/$tdir || error "Can not delete directories"
+}
+run_test 24A "readdir() returns correct number of entries."
+
 test_25a() {
        echo '== symlink sanity ============================================='
 
@@ -1185,7 +1189,7 @@ test_26f() {
        test_mkdir -p $DIR/$tdir
        test_mkdir $DIR/$tdir/$tfile   || error "mkdir $DIR/$tdir/$tfile failed"
        cd $DIR/$tdir/$tfile           || error "cd $DIR/$tdir/$tfile failed"
-       test_mkdir -p lndir bar1      || error "mkdir lndir/bar1 failed"
+       test_mkdir -p lndir/bar1      || error "mkdir lndir/bar1 failed"
        test_mkdir $DIR/$tdir/$tfile/$tfile   || error "mkdir $tfile failed"
        cd $tfile                || error "cd $tfile failed"
        ln -s .. dotdot          || error "ln dotdot failed"
@@ -1217,15 +1221,10 @@ test_27b() {
        $GETSTRIPE -c $DIR/d27/f01
        [ $($GETSTRIPE -c $DIR/d27/f01) -eq 2 ] ||
                error "two-stripe file doesn't have two stripes"
-}
-run_test 27b "create two stripe file"
-
-test_27c() {
-       [ -f $DIR/d27/f01 ] || skip "test_27b not run" && return
 
        dd if=/dev/zero of=$DIR/d27/f01 bs=4k count=4 || error "dd failed"
 }
-run_test 27c "write to two stripe file"
+run_test 27b "create and write to two stripe file"
 
 test_27d() {
        test_mkdir -p $DIR/d27
@@ -1246,7 +1245,7 @@ run_test 27e "setstripe existing file (should return error) ======"
 test_27f() {
        test_mkdir -p $DIR/d27
        $SETSTRIPE -S 100 -i 0 -c 1 $DIR/d27/fbad && error "setstripe failed"
-       dd if=/dev/zero of=$DIR/d27/f12 bs=4k count=4 || error "dd failed"
+       dd if=/dev/zero of=$DIR/d27/fbad bs=4k count=4 || error "dd failed"
        $GETSTRIPE $DIR/d27/fbad || error "$GETSTRIPE failed"
 }
 run_test 27f "setstripe with bad stripe size (should return error)"
@@ -1843,6 +1842,7 @@ test_27C() { #LU-2871
 
        declare -a ost_idx
        local index
+       local found
        local i
        local j
 
@@ -1855,10 +1855,21 @@ test_27C() { #LU-2871
                ost_idx=($($GETSTRIPE $tfile$i |
                         tail -n $((OSTCOUNT + 1)) | awk '{print $1}'))
                echo ${ost_idx[@]}
+
                # check the layout
-               for j in $(seq 0 $((OSTCOUNT - 1))); do
-                       index=$(((i + j) % OSTCOUNT))
-                       [ ${ost_idx[$j]} -eq $index ] || error
+               [ ${#ost_idx[@]} -eq $OSTCOUNT ] ||
+                       error "${#ost_idx[@]} != $OSTCOUNT"
+
+               for index in $(seq 0 $((OSTCOUNT - 1))); do
+                       found=0
+                       for j in $(echo ${ost_idx[@]}); do
+                               if [ $index -eq $j ]; then
+                                       found=1
+                                       break
+                               fi
+                       done
+                       [ $found = 1 ] ||
+                               error "Can not find $index in ${ost_idx[@]}"
                done
        done
 }
@@ -2113,6 +2124,29 @@ test_31n() {
 }
 run_test 31n "check link count of unlinked file"
 
+link_one() {
+       local TEMPNAME=$(mktemp $1_XXXXXX)
+       mlink $TEMPNAME $1 2> /dev/null &&
+               echo "$BASHPID: link $TEMPNAME to $1 succeeded"
+       munlink $TEMPNAME
+}
+
+test_31o() { # LU-2901
+       mkdir -p $DIR/$tdir
+       for LOOP in $(seq 100); do
+               rm -f $DIR/$tdir/$tfile*
+               for THREAD in $(seq 8); do
+                       link_one $DIR/$tdir/$tfile.$LOOP &
+               done
+               wait
+               local LINKS=$(ls -1 $DIR/$tdir | grep -c $tfile.$LOOP)
+               [ $LINKS -gt 1 ] && ls $DIR/$tdir &&
+                       error "$LINKS duplicate links to $tfile.$LOOP" &&
+                       break || true
+       done
+}
+run_test 31o "duplicate hard links with same filename"
+
 cleanup_test32_mount() {
        trap 0
        $UMOUNT $DIR/$tdir/ext2-mountpoint
@@ -2396,7 +2430,7 @@ test_33c() {
         for ostnum in $(seq $OSTCOUNT); do
                 # test-framework's OST numbering is one-based, while Lustre's
                 # is zero-based
-                ostname=$(printf "$FSNAME-OST%.4d" $((ostnum - 1)))
+                ostname=$(printf "$FSNAME-OST%.4x" $((ostnum - 1)))
                 # Parsing llobdstat's output sucks; we could grep the /proc
                 # path, but that's likely to not be as portable as using the
                 # llobdstat utility.  So we parse lctl output instead.
@@ -2420,7 +2454,7 @@ test_33c() {
 
         # Total up write_bytes after writing.  We'd better find non-zeros.
         for ostnum in $(seq $OSTCOUNT); do
-                ostname=$(printf "$FSNAME-OST%.4d" $((ostnum - 1)))
+                ostname=$(printf "$FSNAME-OST%.4x" $((ostnum - 1)))
                 write_bytes=$(do_facet ost$ostnum lctl get_param -n \
                         obdfilter/$ostname/stats |
                         awk '/^write_bytes/ {print $7}' )
@@ -2435,7 +2469,7 @@ test_33c() {
         if $all_zeros
         then
                 for ostnum in $(seq $OSTCOUNT); do
-                        ostname=$(printf "$FSNAME-OST%.4d" $((ostnum - 1)))
+                        ostname=$(printf "$FSNAME-OST%.4x" $((ostnum - 1)))
                         echo "Check that write_bytes is present in obdfilter/*/stats:"
                         do_facet ost$ostnum lctl get_param -n \
                                 obdfilter/$ostname/stats
@@ -2561,6 +2595,12 @@ test_34h() {
             # flush when getting the group lock
        $MULTIOP $DIR/$tfile OG${gid}T${sz}g${gid}c &
        MULTIPID=$!
+
+       # Since just timed wait is not good enough, let's do a sync write
+       # that way we are sure enough time for a roundtrip + processing
+       # passed + 2 seconds of extra margin.
+       dd if=/dev/zero of=$DIR/${tfile}-1 bs=4096 oflag=direct count=1
+       rm $DIR/${tfile}-1
        sleep 2
 
        if [[ `ps h -o comm -p $MULTIPID` == "multiop" ]]; then
@@ -3054,9 +3094,11 @@ test_39m() {
 run_test 39m "test atime and mtime before 1970"
 
 test_40() {
-       dd if=/dev/zero of=$DIR/f40 bs=4096 count=1
-       $RUNAS $OPENFILE -f O_WRONLY:O_TRUNC $DIR/f40 && error
-       $CHECKSTAT -t file -s 4096 $DIR/f40 || error
+       dd if=/dev/zero of=$DIR/$tfile bs=4096 count=1
+       $RUNAS $OPENFILE -f O_WRONLY:O_TRUNC $DIR/$tfile &&
+               error "openfile O_WRONLY:O_TRUNC $tfile failed"
+       $CHECKSTAT -t file -s 4096 $DIR/$tfile ||
+               error "$tfile is not 4096 bytes in size"
 }
 run_test 40 "failed open(O_TRUNC) doesn't truncate ============="
 
@@ -3308,13 +3350,13 @@ test_43a() {
        test_mkdir -p $DIR/$tdir
        cp -p `which $MULTIOP` $DIR/$tdir/multiop ||
                        cp -p multiop $DIR/$tdir/multiop
-        MULTIOP_PROG=$DIR/$tdir/multiop multiop_bg_pause $TMP/test43.junk O_c ||
+       MULTIOP_PROG=$DIR/$tdir/multiop multiop_bg_pause $TMP/$tfile.junk O_c ||
                        return 1
         MULTIOP_PID=$!
         $MULTIOP $DIR/$tdir/multiop Oc && error "expected error, got success"
         kill -USR1 $MULTIOP_PID || return 2
         wait $MULTIOP_PID || return 3
-        rm $TMP/test43.junk
+       rm $TMP/$tfile.junk $DIR/$tdir/multiop
 }
 run_test 43a "open(RDWR) of file being executed should return -ETXTBSY"
 
@@ -3323,13 +3365,13 @@ test_43b() {
        test_mkdir -p $DIR/$tdir
        cp -p `which $MULTIOP` $DIR/$tdir/multiop ||
                        cp -p multiop $DIR/$tdir/multiop
-        MULTIOP_PROG=$DIR/$tdir/multiop multiop_bg_pause $TMP/test43.junk O_c ||
+       MULTIOP_PROG=$DIR/$tdir/multiop multiop_bg_pause $TMP/$tfile.junk O_c ||
                        return 1
         MULTIOP_PID=$!
         $TRUNCATE $DIR/$tdir/multiop 0 && error "expected error, got success"
         kill -USR1 $MULTIOP_PID || return 2
         wait $MULTIOP_PID || return 3
-        rm $TMP/test43.junk
+       rm $TMP/$tfile.junk $DIR/$tdir/multiop
 }
 run_test 43b "truncate of file being executed should return -ETXTBSY"
 
@@ -3591,7 +3633,7 @@ test_50() {
        # bug 1485
        test_mkdir $DIR/$tdir
        cd $DIR/$tdir
-       ls /proc/$$/cwd || error
+       ls /proc/$$/cwd || error "ls /proc/$$/cwd failed"
 }
 run_test 50 "special situations: /proc symlinks  ==============="
 
@@ -3603,13 +3645,13 @@ test_51a() {    # was test_51
        rm $DIR/$tdir/foo
        createmany -m $DIR/$tdir/longfile 201
        FNUM=202
-       while [ `ls -sd $DIR/$tdir | awk '{ print $1 }'` -eq 4 ]; do
+       while [ $(ls -sd $DIR/$tdir | awk '{ print $1 }') -eq 4 ]; do
                $MCREATE $DIR/$tdir/longfile$FNUM
                FNUM=$(($FNUM + 1))
                echo -n "+"
        done
        echo
-       ls -l $DIR/$tdir > /dev/null || error
+       ls -l $DIR/$tdir > /dev/null || error "ls -l $DIR/$tdir failed"
 }
 run_test 51a "special situations: split htree with empty entry =="
 
@@ -3748,13 +3790,13 @@ test_52b() {
                                        error "link worked"
        echo foo >> $DIR/$tdir/foo && error "echo worked"
        mrename $DIR/$tdir/foo $DIR/$tdir/foo_ren && error "rename worked"
-       [ -f $DIR/$tdir/foo ] || error
-       [ -f $DIR/$tdir/foo_ren ] && error
+       [ -f $DIR/$tdir/foo ] || error "$tdir/foo is not a file"
+       [ -f $DIR/$tdir/foo_ren ] && error "$tdir/foo_ren is not a file"
        lsattr $DIR/$tdir/foo | egrep -q "^-+i[-e]+ $DIR/$tdir/foo" ||
                                                        error "lsattr"
        chattr -i $DIR/$tdir/foo || error "chattr failed"
 
-       rm -fr $DIR/$tdir || error
+       rm -fr $DIR/$tdir || error "unable to remove $DIR/$tdir"
 }
 run_test 52b "immutable flag test (should return errors) ======="
 
@@ -3764,37 +3806,56 @@ test_53() {
        remote_ost_nodsh && skip "remote OST with nodsh" && return
 
        local param
+       local param_seq
        local ostname
        local mds_last
+       local mds_last_seq
        local ost_last
+       local ost_last_seq
+       local ost_last_id
        local ostnum
        local node
+       local found=0
 
        # only test MDT0000
         local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS)
         for value in $(do_facet $SINGLEMDS lctl get_param osc.$mdtosc.prealloc_last_id) ; do
-                param=`echo ${value[0]} | cut -d "=" -f1`
-                ostname=`echo $param | cut -d "." -f2 | cut -d - -f 1-2`
-                mds_last=$(do_facet $SINGLEMDS lctl get_param -n $param)
+                param=$(echo ${value[0]} | cut -d "=" -f1)
+                ostname=$(echo $param | cut -d "." -f2 | cut -d - -f 1-2)
+                param_seq=$(echo ${param} |
+                           sed -e s/prealloc_last_id/prealloc_last_seq/g)
+               mds_last_seq=$(do_facet $SINGLEMDS lctl get_param -n $param_seq)
+               mds_last=$(do_facet $SINGLEMDS lctl get_param -n $param)
+
                ostnum=$(index_from_ostuuid ${ostname}_UUID)
                node=$(facet_active_host ost$((ostnum+1)))
                param="obdfilter.$ostname.last_id"
-               ost_last=$(do_node $node lctl get_param -n $param | head -n 1 |
-                          awk -F':' '{print $2}')
-                echo "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
-                if [ $ost_last != $mds_last ]; then
-                    error "$ostname.last_id=$ost_last ; MDS.last_id=$mds_last"
-                fi
+               for ost_last in $(do_node $node lctl get_param -n $param) ; do
+                       echo "$ostname.last_id=$ost_last ;MDS.last_id=$mds_last"
+                       ost_last_id=$(echo $ost_last | awk -F':' '{print $2}' |
+                                     sed -e "s/^0x//g")
+                       ost_last_seq=$(echo $ost_last | awk -F':' '{print $1}')
+                       if [ $ost_last_seq = $mds_last_seq ]; then
+                               if [ $ost_last_id != $mds_last ]; then
+                                       error "$ost_last != $mds_last_id"
+                               else
+                                       found=1
+                                       break
+                               fi
+                       fi
+               done
         done
+       [ $found = 0 ] && error "can not match last_seq/last_id for $mdtosc"
+       return 0
 }
 run_test 53 "verify that MDS and OSTs agree on pre-creation ===="
 
 test_54a() {
-        [ ! -f "$SOCKETSERVER" ] && skip_env "no socketserver, skipping" && return
-        [ ! -f "$SOCKETCLIENT" ] && skip_env "no socketclient, skipping" && return
-       $SOCKETSERVER $DIR/socket
-       $SOCKETCLIENT $DIR/socket || error
-       $MUNLINK $DIR/socket
+       $SOCKETSERVER $DIR/socket ||
+               error "$SOCKETSERVER $DIR/socket failed: $?"
+       $SOCKETCLIENT $DIR/socket ||
+               error "$SOCKETCLIENT $DIR/socket failed: $?"
+       $MUNLINK $DIR/socket || error "$MUNLINK $DIR/socket failed: $?"
 }
 run_test 54a "unix domain socket test =========================="
 
@@ -3802,7 +3863,7 @@ test_54b() {
        f="$DIR/f54b"
        mknod $f c 1 3
        chmod 0666 $f
-       dd if=/dev/zero of=$f bs=`page_size` count=1
+       dd if=/dev/zero of=$f bs=$(page_size) count=1
 }
 run_test 54b "char device works in lustre ======================"
 
@@ -3811,7 +3872,7 @@ find_loop_dev() {
        [ -b /dev/loop0 ] && LOOPBASE=/dev/loop
        [ -z "$LOOPBASE" ] && echo "/dev/loop/0 and /dev/loop0 gone?" && return
 
-       for i in `seq 3 7`; do
+       for i in $(seq 3 7); do
                losetup $LOOPBASE$i > /dev/null 2>&1 && continue
                LOOPDEV=$LOOPBASE$i
                LOOPNUM=$i
@@ -3847,7 +3908,7 @@ test_54d() {
        f="$DIR/f54d"
        string="aaaaaa"
        mknod $f p
-       [ "$string" = `echo $string > $f | cat $f` ] || error
+       [ "$string" = $(echo $string > $f | cat $f) ] || error "$f != $string"
 }
 run_test 54d "fifo device works in lustre ======================"
 
@@ -3856,7 +3917,7 @@ test_54e() {
        f="$DIR/f54e"
        string="aaaaaa"
        cp -aL /dev/console $f
-       echo $string > $f || error
+       echo $string > $f || error "echo $string to $f failed"
 }
 run_test 54e "console/tty device works in lustre ======================"
 
@@ -4559,7 +4620,8 @@ TEST60_HEAD="test_60 run $RANDOM"
 test_60a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        remote_mgs_nodsh && skip "remote MGS with nodsh" && return
-        [ ! -f run-llog.sh ] && skip_env "missing subtest run-llog.sh" && return
+       do_facet mgs "! which run-llog.sh &> /dev/null" &&
+               skip_env "missing subtest run-llog.sh" && return
        log "$TEST60_HEAD - from kernel mode"
        do_facet mgs sh run-llog.sh
 }
@@ -4618,9 +4680,9 @@ run_test 60d "test printk console message masking"
 test_61() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        f="$DIR/f61"
-       dd if=/dev/zero of=$f bs=`page_size` count=1
+       dd if=/dev/zero of=$f bs=$(page_size) count=1 || error "dd $f failed"
        cancel_lru_locks osc
-       $MULTIOP $f OSMWUc || error
+       $MULTIOP $f OSMWUc || error "$MULTIOP $f failed"
        sync
 }
 run_test 61 "mmap() writes don't make sync hang ================"
@@ -4687,8 +4749,7 @@ run_test 64a "verify filter grant calculations (in kernel) ====="
 
 test_64b () {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       [ ! -f oos.sh ] && skip_env "missing subtest oos.sh" && return
-       sh oos.sh $MOUNT
+       sh oos.sh $MOUNT || error "oos.sh failed: $?"
 }
 run_test 64b "check out-of-space detection on client ==========="
 
@@ -5013,26 +5074,29 @@ run_test 71 "Running dbench on lustre (don't segment fault) ===="
 
 test_72a() { # bug 5695 - Test that on 2.6 remove_suid works properly
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       check_kernel_version 43 || return 0
-       [ "$RUNAS_ID" = "$UID" ] && skip_env "RUNAS_ID = UID = $UID -- skipping" && return
+       [ "$RUNAS_ID" = "$UID" ] &&
+               skip_env "RUNAS_ID = UID = $UID -- skipping" && return
 
-        # Check that testing environment is properly set up. Skip if not
-        FAIL_ON_ERROR=false check_runas_id_ret $RUNAS_ID $RUNAS_GID $RUNAS || {
-                skip_env "User $RUNAS_ID does not exist - skipping"
-                return 0
-        }
+       # Check that testing environment is properly set up. Skip if not
+       FAIL_ON_ERROR=false check_runas_id_ret $RUNAS_ID $RUNAS_GID $RUNAS || {
+               skip_env "User $RUNAS_ID does not exist - skipping"
+               return 0
+       }
        # We had better clear the $DIR to get enough space for dd
        rm -rf $DIR/*
-       touch $DIR/f72
-       chmod 777 $DIR/f72
-       chmod ug+s $DIR/f72
-       $RUNAS dd if=/dev/zero of=$DIR/f72 bs=512 count=1 || error
+       touch $DIR/$tfile
+       chmod 777 $DIR/$tfile
+       chmod ug+s $DIR/$tfile
+       $RUNAS dd if=/dev/zero of=$DIR/$tfile bs=512 count=1 ||
+               error "$RUNAS dd $DIR/$tfile failed"
        # See if we are still setuid/sgid
-       test -u $DIR/f72 -o -g $DIR/f72 && error "S/gid is not dropped on write"
+       test -u $DIR/$tfile -o -g $DIR/$tfile &&
+               error "S/gid is not dropped on write"
        # Now test that MDS is updated too
        cancel_lru_locks mdc
-       test -u $DIR/f72 -o -g $DIR/f72 && error "S/gid is not dropped on MDS"
-       rm -f $DIR/f72
+       test -u $DIR/$tfile -o -g $DIR/$tfile &&
+               error "S/gid is not dropped on MDS"
+       rm -f $DIR/$tfile
 }
 run_test 72a "Test that remove suid works properly (bug5695) ===="
 
@@ -5222,68 +5286,55 @@ test_77a() { # bug 10889
        set_checksums 0
        rm -f $DIR/$tfile
 }
-run_test 77a "normal checksum read/write operation ============="
+run_test 77a "normal checksum read/write operation"
 
 test_77b() { # bug 10889
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        $GSS && skip "could not run with gss" && return
        [ ! -f $F77_TMP ] && setup_f77
        #define OBD_FAIL_OSC_CHECKSUM_SEND       0x409
-       lctl set_param fail_loc=0x80000409
+       $LCTL set_param fail_loc=0x80000409
        set_checksums 1
-       dd if=$F77_TMP of=$DIR/f77b bs=1M count=$F77SZ conv=sync || \
+
+       dd if=$F77_TMP of=$DIR/$tfile bs=1M count=$F77SZ conv=sync ||
                error "dd error: $?"
-       lctl set_param fail_loc=0
-       set_checksums 0
-}
-run_test 77b "checksum error on client write ===================="
+       $LCTL set_param fail_loc=0
 
-test_77c() { # bug 10889
-       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       $GSS && skip "could not run with gss" && return
-       [ ! -f $DIR/f77b ] && skip "requires 77b - skipping" && return
-       set_checksums 1
        for algo in $CKSUM_TYPES; do
                cancel_lru_locks osc
                set_checksum_type $algo
                #define OBD_FAIL_OSC_CHECKSUM_RECEIVE    0x408
-               lctl set_param fail_loc=0x80000408
-               cmp $F77_TMP $DIR/f77b || error "file compare failed"
-               lctl set_param fail_loc=0
+               $LCTL set_param fail_loc=0x80000408
+               cmp $F77_TMP $DIR/$tfile || error "file compare failed"
+               $LCTL set_param fail_loc=0
        done
        set_checksums 0
        set_checksum_type $ORIG_CSUM_TYPE
-       rm -f $DIR/f77b
+       rm -f $DIR/$tfile
 }
-run_test 77c "checksum error on client read ==================="
+run_test 77b "checksum error on client write, read"
 
 test_77d() { # bug 10889
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        $GSS && skip "could not run with gss" && return
        #define OBD_FAIL_OSC_CHECKSUM_SEND       0x409
-       lctl set_param fail_loc=0x80000409
+       $LCTL set_param fail_loc=0x80000409
        set_checksums 1
-       directio write $DIR/f77 0 $F77SZ $((1024 * 1024)) || \
+       $DIRECTIO write $DIR/$tfile 0 $F77SZ $((1024 * 1024)) ||
                error "direct write: rc=$?"
-       lctl set_param fail_loc=0
+       $LCTL set_param fail_loc=0
        set_checksums 0
-}
-run_test 77d "checksum error on OST direct write ==============="
 
-test_77e() { # bug 10889
-       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       $GSS && skip "could not run with gss" && return
-       [ ! -f $DIR/f77 ] && skip "requires 77d - skipping" && return
        #define OBD_FAIL_OSC_CHECKSUM_RECEIVE    0x408
-       lctl set_param fail_loc=0x80000408
+       $LCTL set_param fail_loc=0x80000408
        set_checksums 1
        cancel_lru_locks osc
-       directio read $DIR/f77 0 $F77SZ $((1024 * 1024)) || \
+       $DIRECTIO read $DIR/$tfile 0 $F77SZ $((1024 * 1024)) ||
                error "direct read: rc=$?"
-       lctl set_param fail_loc=0
+       $LCTL set_param fail_loc=0
        set_checksums 0
 }
-run_test 77e "checksum error on OST direct read ================"
+run_test 77d "checksum error on OST direct write, read"
 
 test_77f() { # bug 10889
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
@@ -5293,15 +5344,15 @@ test_77f() { # bug 10889
                cancel_lru_locks osc
                set_checksum_type $algo
                #define OBD_FAIL_OSC_CHECKSUM_SEND       0x409
-               lctl set_param fail_loc=0x409
-               directio write $DIR/f77 0 $F77SZ $((1024 * 1024)) && \
+               $LCTL set_param fail_loc=0x409
+               $DIRECTIO write $DIR/$tfile 0 $F77SZ $((1024 * 1024)) &&
                        error "direct write succeeded"
-               lctl set_param fail_loc=0
+               $LCTL set_param fail_loc=0
        done
        set_checksum_type $ORIG_CSUM_TYPE
        set_checksums 0
 }
-run_test 77f "repeat checksum error on write (expect error) ===="
+run_test 77f "repeat checksum error on write (expect error)"
 
 test_77g() { # bug 10889
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
@@ -5310,32 +5361,24 @@ test_77g() { # bug 10889
 
        [ ! -f $F77_TMP ] && setup_f77
 
-       $SETSTRIPE -c 1 -i 0 $DIR/f77g
+       $SETSTRIPE -c 1 -i 0 $DIR/$tfile
        #define OBD_FAIL_OST_CHECKSUM_RECEIVE       0x21a
        do_facet ost1 lctl set_param fail_loc=0x8000021a
        set_checksums 1
-       dd if=$F77_TMP of=$DIR/f77g bs=1M count=$F77SZ || \
+       dd if=$F77_TMP of=$DIR/$tfile bs=1M count=$F77SZ ||
                error "write error: rc=$?"
        do_facet ost1 lctl set_param fail_loc=0
        set_checksums 0
-}
-run_test 77g "checksum error on OST write ======================"
-
-test_77h() { # bug 10889
-       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       $GSS && skip "could not run with gss" && return
-       remote_ost_nodsh && skip "remote OST with nodsh" && return
 
-       [ ! -f $DIR/f77g ] && skip "requires 77g - skipping" && return
        cancel_lru_locks osc
        #define OBD_FAIL_OST_CHECKSUM_SEND          0x21b
        do_facet ost1 lctl set_param fail_loc=0x8000021b
        set_checksums 1
-       cmp $F77_TMP $DIR/f77g || error "file compare failed"
+       cmp $F77_TMP $DIR/$tfile || error "file compare failed"
        do_facet ost1 lctl set_param fail_loc=0
        set_checksums 0
 }
-run_test 77h "checksum error on OST read ======================="
+run_test 77g "checksum error on OST write, read"
 
 test_77i() { # bug 13805
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
@@ -5351,7 +5394,7 @@ test_77i() { # bug 13805
        done
        remount_client $MOUNT
 }
-run_test 77i "client not supporting OSD_CONNECT_CKSUM =========="
+run_test 77i "client not supporting OSD_CONNECT_CKSUM"
 
 test_77j() { # bug 13805
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
@@ -5368,7 +5411,7 @@ test_77j() { # bug 13805
        done
        remount_client $MOUNT
 }
-run_test 77j "client only supporting ADLER32 ===================="
+run_test 77j "client only supporting ADLER32"
 
 [ "$ORIG_CSUM" ] && set_checksums $ORIG_CSUM || true
 rm -f $F77_TMP
@@ -5534,20 +5577,21 @@ test_82() { # LU-1031
 run_test 82 "Basic grouplock test ==============================="
 
 test_99a() {
-        [ -z "$(which cvs 2>/dev/null)" ] && skip_env "could not find cvs" && \
-           return
+       [ -z "$(which cvs 2>/dev/null)" ] && skip_env "could not find cvs" &&
+               return
        test_mkdir -p $DIR/d99cvsroot
        chown $RUNAS_ID $DIR/d99cvsroot
        local oldPWD=$PWD       # bug 13584, use $TMP as working dir
        cd $TMP
 
-       $RUNAS cvs -d $DIR/d99cvsroot init || error
+       $RUNAS cvs -d $DIR/d99cvsroot init || error "cvs init failed"
        cd $oldPWD
 }
 run_test 99a "cvs init ========================================="
 
 test_99b() {
-        [ -z "$(which cvs 2>/dev/null)" ] && skip_env "could not find cvs" && return
+       [ -z "$(which cvs 2>/dev/null)" ] &&
+               skip_env "could not find cvs" && return
        [ ! -d $DIR/d99cvsroot ] && test_99a
        cd /etc/init.d
        # some versions of cvs import exit(1) when asked to import links or
@@ -5960,19 +6004,21 @@ test_102a() {
        touch $testfile
 
        [ "$UID" != 0 ] && skip_env "must run as root" && return
-       [ -z "`lctl get_param -n mdc.*-mdc-*.connect_flags | grep xattr`" ] &&
+       [ -z "$(lctl get_param -n mdc.*-mdc-*.connect_flags | grep xattr)" ] &&
                skip_env "must have user_xattr" && return
 
        [ -z "$(which setfattr 2>/dev/null)" ] &&
                skip_env "could not find setfattr" && return
 
        echo "set/get xattr..."
-       setfattr -n trusted.name1 -v value1 $testfile || error
+       setfattr -n trusted.name1 -v value1 $testfile ||
+               error "setfattr -n trusted.name1=value1 $testfile failed"
        getfattr -n trusted.name1 $testfile 2> /dev/null |
          grep "trusted.name1=.value1" ||
                error "$testfile missing trusted.name1=value1"
 
-       setfattr -n user.author1 -v author1 $testfile || error
+       setfattr -n user.author1 -v author1 $testfile ||
+               error "setfattr -n user.author1=author1 $testfile failed"
        getfattr -n user.author1 $testfile 2> /dev/null |
          grep "user.author1=.author1" ||
                error "$testfile missing trusted.author1=author1"
@@ -6253,51 +6299,53 @@ run_acl_subtest()
 }
 
 test_103 () {
-    [ "$UID" != 0 ] && skip_env "must run as root" && return
-    [ -z "$(lctl get_param -n mdc.*-mdc-*.connect_flags | grep acl)" ] && skip "must have acl enabled" && return
-    [ -z "$(which setfacl 2>/dev/null)" ] && skip_env "could not find setfacl" && return
-    $GSS && skip "could not run under gss" && return
+       [ "$UID" != 0 ] && skip_env "must run as root" && return
+       [ -z "$(lctl get_param -n mdc.*-mdc-*.connect_flags | grep acl)" ] &&
+               skip "must have acl enabled" && return
+       [ -z "$(which setfacl 2>/dev/null)" ] &&
+               skip_env "could not find setfacl" && return
+       $GSS && skip "could not run under gss" && return
 
-    declare -a identity_old
+       declare -a identity_old
 
        for num in $(seq $MDSCOUNT); do
                switch_identity $num true || identity_old[$num]=$?
        done
 
-    SAVE_UMASK=`umask`
-    umask 0022
-    cd $DIR
-
-    echo "performing cp ..."
-    run_acl_subtest cp || error
-    echo "performing getfacl-noacl..."
-    run_acl_subtest getfacl-noacl || error "getfacl-noacl test failed"
-    echo "performing misc..."
-    run_acl_subtest misc || error  "misc test failed"
-    echo "performing permissions..."
-    run_acl_subtest permissions || error "permissions failed"
-    echo "performing setfacl..."
-    run_acl_subtest setfacl || error  "setfacl test failed"
-
-    # inheritance test got from HP
-    echo "performing inheritance..."
-    cp $LUSTRE/tests/acl/make-tree . || error "cannot copy make-tree"
-    chmod +x make-tree || error "chmod +x failed"
-    run_acl_subtest inheritance || error "inheritance test failed"
-    rm -f make-tree
+       SAVE_UMASK=$(umask)
+       umask 0022
+       cd $DIR
+
+       echo "performing cp ..."
+       run_acl_subtest cp || error "run_acl_subtest cp failed"
+       echo "performing getfacl-noacl..."
+       run_acl_subtest getfacl-noacl || error "getfacl-noacl test failed"
+       echo "performing misc..."
+       run_acl_subtest misc || error  "misc test failed"
+       echo "performing permissions..."
+       run_acl_subtest permissions || error "permissions failed"
+       echo "performing setfacl..."
+       run_acl_subtest setfacl || error  "setfacl test failed"
+
+       # inheritance test got from HP
+       echo "performing inheritance..."
+       cp $LUSTRE/tests/acl/make-tree . || error "cannot copy make-tree"
+       chmod +x make-tree || error "chmod +x failed"
+       run_acl_subtest inheritance || error "inheritance test failed"
+       rm -f make-tree
 
        echo "LU-974 ignore umask when acl is enabled..."
-       run_acl_subtest 974 || error "LU-974 test failed"
+       run_acl_subtest 974 || error "LU-974 umask test failed"
        if [ $MDSCOUNT -ge 2 ]; then
                run_acl_subtest 974_remote ||
-                       error "LU-974 test failed under remote dir"
+                       error "LU-974 umask test failed under remote dir"
        fi
 
-    echo "LU-2561 newly created file is same size as directory..."
-    run_acl_subtest 2561 || error "LU-2561 test failed"
+       echo "LU-2561 newly created file is same size as directory..."
+       run_acl_subtest 2561 || error "LU-2561 test failed"
 
-    cd $SAVE_PWD
-    umask $SAVE_UMASK
+       cd $SAVE_PWD
+       umask $SAVE_UMASK
 
        for num in $(seq $MDSCOUNT); do
                if [ "${identity_old[$num]}" = 1 ]; then
@@ -6317,12 +6365,12 @@ test_104a() {
        lfs df $DIR/$tfile || error "lfs df $DIR/$tfile failed"
        lfs df -ih $DIR/$tfile || error "lfs df -ih $DIR/$tfile failed"
 
-        OSC=`lctl dl |grep OST0000-osc-[^M] |awk '{print $4}'`
+       local OSC=$(lctl dl | grep OST0000-osc-[^M] | awk '{ print $4 }')
        lctl --device %$OSC deactivate
        lfs df || error "lfs df with deactivated OSC failed"
        lctl --device %$OSC activate
-        # wait the osc back to normal
-        wait_osc_import_state client ost FULL
+       # wait the osc back to normal
+       wait_osc_import_state client ost FULL
 
        lfs df || error "lfs df with reactivated OSC failed"
        rm -f $DIR/$tfile
@@ -6331,12 +6379,13 @@ run_test 104a "lfs df [-ih] [path] test ========================="
 
 test_104b() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       [ $RUNAS_ID -eq $UID ] && skip_env "RUNAS_ID = UID = $UID -- skipping" && return
+       [ $RUNAS_ID -eq $UID ] &&
+               skip_env "RUNAS_ID = UID = $UID -- skipping" && return
        chmod 666 /dev/obd
-       denied_cnt=$((`$RUNAS $LFS check servers 2>&1 | grep "Permission denied" | wc -l`))
-       if [ $denied_cnt -ne 0 ];
-       then
-                   error "lfs check servers test failed"
+       denied_cnt=$(($($RUNAS $LFS check servers 2>&1 |
+                       grep "Permission denied" | wc -l)))
+       if [ $denied_cnt -ne 0 ]; then
+               error "lfs check servers test failed"
        fi
 }
 run_test 104b "$RUNAS lfs check servers test ===================="
@@ -6344,7 +6393,7 @@ run_test 104b "$RUNAS lfs check servers test ===================="
 test_105a() {
        # doesn't work on 2.4 kernels
        touch $DIR/$tfile
-       if [ -n "`mount | grep \"$MOUNT.*flock\" | grep -v noflock`" ]; then
+       if [ -n "$(mount | grep "$MOUNT.*flock" | grep -v noflock)" ]; then
                flocks_test 1 on -f $DIR/$tfile || error "fail flock on"
        else
                flocks_test 1 off -f $DIR/$tfile || error "fail flock off"
@@ -6355,7 +6404,7 @@ run_test 105a "flock when mounted without -o flock test ========"
 
 test_105b() {
        touch $DIR/$tfile
-       if [ -n "`mount | grep \"$MOUNT.*flock\" | grep -v noflock`" ]; then
+       if [ -n "$(mount | grep "$MOUNT.*flock" | grep -v noflock)" ]; then
                flocks_test 1 on -c $DIR/$tfile || error "fail flock on"
        else
                flocks_test 1 off -c $DIR/$tfile || error "fail flock off"
@@ -6366,7 +6415,7 @@ run_test 105b "fcntl when mounted without -o flock test ========"
 
 test_105c() {
        touch $DIR/$tfile
-       if [ -n "`mount | grep \"$MOUNT.*flock\" | grep -v noflock`" ]; then
+       if [ -n "$(mount | grep "$MOUNT.*flock" | grep -v noflock)" ]; then
                flocks_test 1 on -l $DIR/$tfile || error "fail flock on"
        else
                flocks_test 1 off -l $DIR/$tfile || error "fail flock off"
@@ -6378,7 +6427,7 @@ run_test 105c "lockf when mounted without -o flock test ========"
 test_105d() { # bug 15924
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        test_mkdir -p $DIR/$tdir
-       [ -z "`mount | grep \"$MOUNT.*flock\" | grep -v noflock`" ] && \
+       [ -z "$(mount | grep "$MOUNT.*flock" | grep -v noflock)" ] &&
                skip "mount w/o flock enabled" && return
        #define OBD_FAIL_LDLM_CP_CB_WAIT  0x315
        $LCTL set_param fail_loc=0x80000315
@@ -6387,7 +6436,7 @@ test_105d() { # bug 15924
 run_test 105d "flock race (should not freeze) ========"
 
 test_105e() { # bug 22660 && 22040
-       [ -z "`mount | grep \"$MOUNT.*flock\" | grep -v noflock`" ] && \
+       [ -z "$(mount | grep "$MOUNT.*flock" | grep -v noflock)" ] &&
                skip "mount w/o flock enabled" && return
        touch $DIR/$tfile
        flocks_test 3 $DIR/$tfile
@@ -7082,9 +7131,13 @@ test_120a() {
         test_mkdir -p $DIR/$tdir
         [ -z "`lctl get_param -n mdc.*.connect_flags | grep early_lock_cancel`" ] && \
                skip "no early lock cancel on server" && return 0
-        lru_resize_disable mdc
-        lru_resize_disable osc
-        cancel_lru_locks mdc
+
+       lru_resize_disable mdc
+       lru_resize_disable osc
+       cancel_lru_locks mdc
+       # asynchronous object destroy at MDT could cause bl ast to client
+       cancel_lru_locks osc
+
         stat $DIR/$tdir > /dev/null
         can1=`lctl get_param -n ldlm.services.ldlm_canceld.stats | awk '/ldlm_cancel/ {print $2}'`
         blk1=`lctl get_param -n ldlm.services.ldlm_cbd.stats | awk '/ldlm_bl_callback/ {print $2}'`
@@ -7126,7 +7179,8 @@ test_120c() {
                skip "no early lock cancel on server" && return 0
         lru_resize_disable mdc
         lru_resize_disable osc
-        test_mkdir -p $DIR/$tdir/d1 $DIR/$tdir/d2
+       test_mkdir -p $DIR/$tdir/d1
+       test_mkdir -p $DIR/$tdir/d2
         touch $DIR/$tdir/d1/f1
         cancel_lru_locks mdc
         stat $DIR/$tdir/d1 $DIR/$tdir/d2 $DIR/$tdir/d1/f1 > /dev/null
@@ -7199,7 +7253,8 @@ test_120f() {
         test_mkdir -p $DIR/$tdir
         lru_resize_disable mdc
         lru_resize_disable osc
-        test_mkdir -p $DIR/$tdir/d1 $DIR/$tdir/d2
+       test_mkdir -p $DIR/$tdir/d1
+       test_mkdir -p $DIR/$tdir/d2
         dd if=/dev/zero of=$DIR/$tdir/d1/f1 count=1
         dd if=/dev/zero of=$DIR/$tdir/d2/f2 count=1
         cancel_lru_locks mdc
@@ -7687,31 +7742,44 @@ test_129() {
        fi
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
 
+       ENOSPC=28
        EFBIG=27
-       MAX=16384
 
-       set_dir_limits $MAX
        test_mkdir -p $DIR/$tdir
 
+       MAX=$(stat -c%s "$DIR/$tdir")
+       set_dir_limits $MAX
        local I=0
        local J=0
-       while [ ! $I -gt $((MAX * MDSCOUNT)) ]; do
+       while [ ! $I -gt $MAX ]; do
                $MULTIOP $DIR/$tdir/$J Oc
                rc=$?
-               if [ $rc -eq $EFBIG ]; then
+               #check two errors ENOSPC for new version of ext4 max_dir_size patch
+               #mainline kernel commit df981d03eeff7971ac7e6ff37000bfa702327ef1
+               #and EFBIG for previous versions
+               if [ $rc -eq $EFBIG -o $rc -eq $ENOSPC ] && [ $I -gt 0 ]; then
                        set_dir_limits 0
                        echo "return code $rc received as expected"
-                       return 0
+                       multiop $DIR/$tdir/$J Oc
+                       rc=$?
+                       I=$(stat -c%s "$DIR/$tdir")
+                       if [ $I -gt $MAX ] && [ $rc -eq 0 ]; then
+                               return 0
+                       else
+                               error_exit "return code $rc current dir size $I " \
+                                          "previous limit $MAX"
+                       fi
                elif [ $rc -ne 0 ]; then
                        set_dir_limits 0
-                       error_exit "return code $rc received instead of expected $EFBIG"
+                       error_exit "return code $rc received instead of expected " \
+                                  "$EFBIG or $ENOSPC, files in dir $I"
                fi
                J=$((J+1))
                I=$(stat -c%s "$DIR/$tdir")
        done
 
        set_dir_limits 0
-       error "exceeded dir size limit $MAX x $MDSCOUNT $((MAX * MDSCOUNT)) : $I bytes"
+       error "exceeded dir size limit $MAX x $MDSCOUNT $MAX : $I bytes"
 }
 run_test 129 "test directory size limit ========================"
 
@@ -7775,6 +7843,9 @@ test_130b() {
        [ "$OSTCOUNT" -lt "2" ] &&
                skip_env "skipping FIEMAP on 2-stripe file test" && return
 
+       [ "$OSTCOUNT" -ge "10" ] &&
+               skip_env "skipping FIEMAP with >= 10 OSTs" && return
+
        local filefrag_op=$(filefrag -e 2>&1 | grep "invalid option")
        [ -n "$filefrag_op" ] && skip_env "filefrag does not support FIEMAP" &&
                return
@@ -7831,6 +7902,9 @@ test_130c() {
        [ "$OSTCOUNT" -lt "2" ] &&
                skip_env "skipping FIEMAP on 2-stripe file" && return
 
+       [ "$OSTCOUNT" -ge "10" ] &&
+               skip_env "skipping FIEMAP with >= 10 OSTs" && return
+
        filefrag_op=$(filefrag -e 2>&1 | grep "invalid option")
        [ -n "$filefrag_op" ] && skip "filefrag does not support FIEMAP" &&
                return
@@ -7890,6 +7964,9 @@ run_test 130c "FIEMAP (2-stripe file with hole)"
 test_130d() {
        [ "$OSTCOUNT" -lt "3" ] && skip_env "skipping FIEMAP on N-stripe file test" && return
 
+       [ "$OSTCOUNT" -ge "10" ] &&
+               skip_env "skipping FIEMAP with >= 10 OSTs" && return
+
        filefrag_op=$(filefrag -e 2>&1 | grep "invalid option")
        [ -n "$filefrag_op" ] && skip "filefrag does not support FIEMAP" && return
 
@@ -7941,6 +8018,9 @@ run_test 130d "FIEMAP (N-stripe file)"
 test_130e() {
        [ "$OSTCOUNT" -lt "2" ] && skip_env "skipping continuation FIEMAP test" && return
 
+       [ "$OSTCOUNT" -ge "10" ] &&
+               skip_env "skipping FIEMAP with >= 10 OSTs" && return
+
        filefrag_op=$(filefrag -e 2>&1 | grep "invalid option")
        [ -n "$filefrag_op" ] && skip "filefrag does not support FIEMAP" && return
 
@@ -8557,17 +8637,17 @@ test_151() {
                return 0
        fi
 
-#define OBD_FAIL_OBD_NO_LRU  0x609
+       #define OBD_FAIL_OBD_NO_LRU  0x609
        do_nodes $list $LCTL set_param fail_loc=0x609
 
        # pages should be in the case right after write
        dd if=/dev/urandom of=$DIR/$tfile bs=4k count=$CPAGES ||
                error "dd failed"
 
-       local BEFORE=`roc_hit`
+       local BEFORE=$(roc_hit)
        cancel_lru_locks osc
        cat $DIR/$tfile >/dev/null
-       local AFTER=`roc_hit`
+       local AFTER=$(roc_hit)
 
        do_nodes $list $LCTL set_param fail_loc=0
 
@@ -8581,10 +8661,10 @@ test_151() {
         cat $DIR/$tfile >/dev/null
 
         # now data shouldn't be found in the cache
-        BEFORE=`roc_hit`
+       BEFORE=$(roc_hit)
         cancel_lru_locks osc
         cat $DIR/$tfile >/dev/null
-        AFTER=`roc_hit`
+       AFTER=$(roc_hit)
         if let "AFTER - BEFORE != 0"; then
                 error "IN CACHE: before: $BEFORE, after: $AFTER"
         fi
@@ -8709,25 +8789,23 @@ dot_lustre_fid_permission_check() {
        mrename $test_dir/$tdir $MOUNT/.lustre/fid &&
                error "rename to $MOUNT/.lustre/fid should fail."
 
-       echo "rename .lustre to itself"
-       fid=$($LFS path2fid $MOUNT)
-       mrename $MOUNT/.lustre $MOUNT/.lustre/fid/$fid/.lustre &&
-               error "rename .lustre to itself should fail."
+       if [ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.51) ]
+       then            # LU-3547
+               local old_obf_mode=$(stat --format="%a" $DIR/.lustre/fid)
+               local new_obf_mode=777
 
-       local old_obf_mode=$(stat --format="%a" $DIR/.lustre/fid)
-       local new_obf_mode=777
+               echo "change mode of $DIR/.lustre/fid to $new_obf_mode"
+               chmod $new_obf_mode $DIR/.lustre/fid ||
+                       error "chmod $new_obf_mode $DIR/.lustre/fid failed"
 
-       echo "change mode of $DIR/.lustre/fid to $new_obf_mode"
-       chmod $new_obf_mode $DIR/.lustre/fid ||
-               error "chmod $new_obf_mode $DIR/.lustre/fid failed"
+               local obf_mode=$(stat --format=%a $DIR/.lustre/fid)
+               [ $obf_mode -eq $new_obf_mode ] ||
+                       error "stat $DIR/.lustre/fid returned wrong mode $obf_mode"
 
-       local obf_mode=$(stat --format=%a $DIR/.lustre/fid)
-       [ $obf_mode -eq $new_obf_mode ] ||
-               error "stat $DIR/.lustre/fid returned wrong mode $obf_mode"
-
-       echo "restore mode of $DIR/.lustre/fid to $old_obf_mode"
-       chmod $old_obf_mode $DIR/.lustre/fid ||
-               error "chmod $old_obf_mode $DIR/.lustre/fid failed"
+               echo "restore mode of $DIR/.lustre/fid to $old_obf_mode"
+               chmod $old_obf_mode $DIR/.lustre/fid ||
+                       error "chmod $old_obf_mode $DIR/.lustre/fid failed"
+       fi
 
        $OPENFILE -f O_LOV_DELAY_CREATE:O_CREAT $test_dir/$tfile-2
        fid=$($LFS path2fid $test_dir/$tfile-2)
@@ -8745,6 +8823,24 @@ dot_lustre_fid_permission_check() {
        rm -rf $test_dir/$tfile-2
 }
 
+test_154A() {
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.4.1) ]] &&
+               skip "Need MDS version at least 2.4.1" && return
+
+       touch $DIR/$tfile
+       local FID=$($LFS path2fid $DIR/$tfile)
+       [ -z "$FID" ] && error "path2fid unable to get $DIR/$tfile FID"
+
+       # check that we get the same pathname back
+       local FOUND=$($LFS fid2path $MOUNT $FID)
+       [ -z "$FOUND" ] && error "fid2path unable to get $FID path"
+       [ "$FOUND" != "$DIR/$tfile" ] &&
+               error "fid2path(path2fid($DIR/$tfile)) = $FOUND != $DIR/$tfile"
+
+       rm -rf $DIR/$tfile
+}
+run_test 154A "lfs path2fid and fid2path basic checks"
+
 test_154a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.51) ]] ||
@@ -8798,6 +8894,33 @@ test_154b() {
 }
 run_test 154b "Open-by-FID for remote directory"
 
+test_154c() {
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.4.1) ]] &&
+               skip "Need MDS version at least 2.4.1" && return
+
+       touch $DIR/$tfile.1 $DIR/$tfile.2 $DIR/$tfile.3
+       local FID1=$($LFS path2fid $DIR/$tfile.1)
+       local FID2=$($LFS path2fid $DIR/$tfile.2)
+       local FID3=$($LFS path2fid $DIR/$tfile.3)
+
+       local N=1
+       $LFS path2fid $DIR/$tfile.[123] | while read PATHNAME FID; do
+               [ "$PATHNAME" = "$DIR/$tfile.$N:" ] ||
+                       error "path2fid pathname $PATHNAME != $DIR/$tfile.$N:"
+               local want=FID$N
+               [ "$FID" = "${!want}" ] ||
+                       error "path2fid $PATHNAME FID $FID != FID$N ${!want}"
+               N=$((N + 1))
+       done
+
+       $LFS fid2path $MOUNT $FID1 $FID2 $FID3 | while read PATHNAME; do
+               [ "$PATHNAME" = "$DIR/$tfile.$N" ] ||
+                       error "fid2path pathname $PATHNAME != $DIR/$tfile.$N:"
+               N=$((N + 1))
+       done
+}
+run_test 154c "lfs path2fid and fid2path multiple arguments"
+
 test_155_small_load() {
     local temp=$TMP/$tfile
     local file=$DIR/$tfile
@@ -9063,113 +9186,132 @@ run_test 156 "Verification of tunables ============================"
 
 #Changelogs
 err17935 () {
-    if [ $MDSCOUNT -gt 1 ]; then
-       error_ignore 17935 $*
-    else
-       error $*
-    fi
+       if [ $MDSCOUNT -gt 1 ]; then
+               error_ignore 17935 $*
+       else
+               error $*
+       fi
 }
 
 changelog_chmask()
 {
-    MASK=$(do_facet $SINGLEMDS $LCTL get_param mdd.$MDT0.changelog_mask |\
-           grep -c $1)
+       local CL_MASK_PARAM="mdd.$MDT0.changelog_mask"
 
-    if [ $MASK -eq 1 ]; then
-        do_facet $SINGLEMDS $LCTL set_param mdd.$MDT0.changelog_mask="-$1"
-    else
-        do_facet $SINGLEMDS $LCTL set_param mdd.$MDT0.changelog_mask="+$1"
-    fi
+       MASK=$(do_facet $SINGLEMDS $LCTL get_param $CL_MASK_PARAM| grep -c "$1")
+
+       if [ $MASK -eq 1 ]; then
+               do_facet $SINGLEMDS $LCTL set_param $CL_MASK_PARAM="-$1"
+       else
+               do_facet $SINGLEMDS $LCTL set_param $CL_MASK_PARAM="+$1"
+       fi
+}
+
+changelog_extract_field() {
+       local mdt=$1
+       local cltype=$2
+       local file=$3
+       local identifier=$4
+
+       $LFS changelog $mdt | gawk "/$cltype.*$file$/ {
+               print gensub(/^.* "$identifier'(\[[^\]]*\]).*$/,"\\1",1)}' |
+               tail -1
 }
 
 test_160() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-    remote_mds_nodsh && skip "remote MDS with nodsh" && return
-    [ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.0) ] ||
-        { skip "Need MDS version at least 2.2.0"; return; }
-    USER=$(do_facet $SINGLEMDS $LCTL --device $MDT0 changelog_register -n)
-    echo "Registered as changelog user $USER"
-    do_facet $SINGLEMDS $LCTL get_param -n mdd.$MDT0.changelog_users | \
-       grep -q $USER || error "User $USER not found in changelog_users"
-
-    # change something
-    test_mkdir -p $DIR/$tdir/pics/2008/zachy
-    touch $DIR/$tdir/pics/2008/zachy/timestamp
-    cp /etc/hosts $DIR/$tdir/pics/2008/zachy/pic1.jpg
-    mv $DIR/$tdir/pics/2008/zachy $DIR/$tdir/pics/zach
-    ln $DIR/$tdir/pics/zach/pic1.jpg $DIR/$tdir/pics/2008/portland.jpg
-    ln -s $DIR/$tdir/pics/2008/portland.jpg $DIR/$tdir/pics/desktop.jpg
-    rm $DIR/$tdir/pics/desktop.jpg
-
-    $LFS changelog $MDT0 | tail -5
-
-    echo "verifying changelog mask"
-    changelog_chmask "MKDIR"
-    changelog_chmask "CLOSE"
-
-    test_mkdir -p $DIR/$tdir/pics/zach/sofia
-    echo "zzzzzz" > $DIR/$tdir/pics/zach/file
-
-    changelog_chmask "MKDIR"
-    changelog_chmask "CLOSE"
-
-    test_mkdir -p $DIR/$tdir/pics/2008/sofia
-    echo "zzzzzz" > $DIR/$tdir/pics/zach/file
-
-    $LFS changelog $MDT0
-    MKDIRS=$($LFS changelog $MDT0 | tail -5 | grep -c "MKDIR")
-    CLOSES=$($LFS changelog $MDT0 | tail -5 | grep -c "CLOSE")
-    [ $MKDIRS -eq 1 ] || err17935 "MKDIR changelog mask count $DIRS != 1"
-    [ $CLOSES -eq 1 ] || err17935 "CLOSE changelog mask count $DIRS != 1"
-
-    # verify contents
-    echo "verifying target fid"
-    fidc=$($LFS changelog $MDT0 | grep timestamp | grep "CREAT" | \
-       tail -1 | awk '{print $6}')
-    fidf=$($LFS path2fid $DIR/$tdir/pics/zach/timestamp)
-    [ "$fidc" == "t=$fidf" ] || \
-       err17935 "fid in changelog $fidc != file fid $fidf"
-    echo "verifying parent fid"
-    fidc=$($LFS changelog $MDT0 | grep timestamp | grep "CREAT" | \
-       tail -1 | awk '{print $7}')
-    fidf=$($LFS path2fid $DIR/$tdir/pics/zach)
-    [ "$fidc" == "p=$fidf" ] || \
-       err17935 "pfid in changelog $fidc != dir fid $fidf"
-
-    USER_REC1=$(do_facet $SINGLEMDS $LCTL get_param -n \
-       mdd.$MDT0.changelog_users | grep $USER | awk '{print $2}')
-    $LFS changelog_clear $MDT0 $USER $(($USER_REC1 + 5))
-    USER_REC2=$(do_facet $SINGLEMDS $LCTL get_param -n \
-       mdd.$MDT0.changelog_users | grep $USER | awk '{print $2}')
-    echo "verifying user clear: $(( $USER_REC1 + 5 )) == $USER_REC2"
-    [ $USER_REC2 == $(($USER_REC1 + 5)) ] || \
-       err17935 "user index should be $(($USER_REC1 + 5)); is $USER_REC2"
-
-    MIN_REC=$(do_facet $SINGLEMDS $LCTL get_param mdd.$MDT0.changelog_users | \
-       awk 'min == "" || $2 < min {min = $2}; END {print min}')
-    FIRST_REC=$($LFS changelog $MDT0 | head -1 | awk '{print $1}')
-    echo "verifying min purge: $(( $MIN_REC + 1 )) == $FIRST_REC"
-    [ $FIRST_REC == $(($MIN_REC + 1)) ] || \
-       err17935 "first index should be $(($MIN_REC + 1)); is $FIRST_REC"
-
-    echo "verifying user deregister"
-    do_facet $SINGLEMDS $LCTL --device $MDT0 changelog_deregister $USER
-    do_facet $SINGLEMDS $LCTL get_param -n mdd.$MDT0.changelog_users | \
-       grep -q $USER && error "User $USER still found in changelog_users"
-
-    USERS=$(( $(do_facet $SINGLEMDS $LCTL get_param -n \
-       mdd.$MDT0.changelog_users | wc -l) - 2 ))
-    if [ $USERS -eq 0 ]; then
-       LAST_REC1=$(do_facet $SINGLEMDS $LCTL get_param -n \
-           mdd.$MDT0.changelog_users | head -1 | awk '{print $3}')
-       touch $DIR/$tdir/chloe
-       LAST_REC2=$(do_facet $SINGLEMDS $LCTL get_param -n \
-           mdd.$MDT0.changelog_users | head -1 | awk '{print $3}')
-       echo "verify changelogs are off if we were the only user: $LAST_REC1 == $LAST_REC2"
-       [ $LAST_REC1 == $LAST_REC2 ] || error "changelogs not off"
-    else
-       echo "$USERS other changelog users; can't verify off"
-    fi
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       [ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.0) ] ||
+               { skip "Need MDS version at least 2.2.0"; return; }
+
+       local CL_USERS="mdd.$MDT0.changelog_users"
+       local GET_CL_USERS="do_facet $SINGLEMDS $LCTL get_param -n $CL_USERS"
+       USER=$(do_facet $SINGLEMDS $LCTL --device $MDT0 changelog_register -n)
+       echo "Registered as changelog user $USER"
+       $GET_CL_USERS | grep -q $USER ||
+               error "User $USER not found in changelog_users"
+
+       # change something
+       test_mkdir -p $DIR/$tdir/pics/2008/zachy
+       touch $DIR/$tdir/pics/2008/zachy/timestamp
+       cp /etc/hosts $DIR/$tdir/pics/2008/zachy/pic1.jpg
+       mv $DIR/$tdir/pics/2008/zachy $DIR/$tdir/pics/zach
+       ln $DIR/$tdir/pics/zach/pic1.jpg $DIR/$tdir/pics/2008/portland.jpg
+       ln -s $DIR/$tdir/pics/2008/portland.jpg $DIR/$tdir/pics/desktop.jpg
+       rm $DIR/$tdir/pics/desktop.jpg
+
+       $LFS changelog $MDT0 | tail -5
+
+       echo "verifying changelog mask"
+       changelog_chmask "MKDIR"
+       changelog_chmask "CLOSE"
+
+       test_mkdir -p $DIR/$tdir/pics/zach/sofia
+       echo "zzzzzz" > $DIR/$tdir/pics/zach/file
+
+       changelog_chmask "MKDIR"
+       changelog_chmask "CLOSE"
+
+       test_mkdir -p $DIR/$tdir/pics/2008/sofia
+       echo "zzzzzz" > $DIR/$tdir/pics/zach/file
+
+       $LFS changelog $MDT0
+       MKDIRS=$($LFS changelog $MDT0 | tail -5 | grep -c "MKDIR")
+       CLOSES=$($LFS changelog $MDT0 | tail -5 | grep -c "CLOSE")
+       [ $MKDIRS -eq 1 ] || err17935 "MKDIR changelog mask count $DIRS != 1"
+       [ $CLOSES -eq 1 ] || err17935 "CLOSE changelog mask count $DIRS != 1"
+
+       # verify contents
+       echo "verifying target fid"
+       fidc=$(changelog_extract_field $MDT0 "CREAT" "timestamp" "t=")
+       fidf=$($LFS path2fid $DIR/$tdir/pics/zach/timestamp)
+       [ "$fidc" == "$fidf" ] ||
+               err17935 "fid in changelog $fidc != file fid $fidf"
+       echo "verifying parent fid"
+       fidc=$(changelog_extract_field $MDT0 "CREAT" "timestamp" "p=")
+       fidf=$($LFS path2fid $DIR/$tdir/pics/zach)
+       [ "$fidc" == "$fidf" ] ||
+               err17935 "pfid in changelog $fidc != dir fid $fidf"
+
+       USER_REC1=$($GET_CL_USERS | awk "\$1 == \"$USER\" {print \$2}")
+       $LFS changelog_clear $MDT0 $USER $(($USER_REC1 + 5))
+       USER_REC2=$($GET_CL_USERS | awk "\$1 == \"$USER\" {print \$2}")
+       echo "verifying user clear: $(( $USER_REC1 + 5 )) == $USER_REC2"
+       [ $USER_REC2 == $(($USER_REC1 + 5)) ] ||
+               err17935 "user index expected $(($USER_REC1 + 5)) is $USER_REC2"
+
+       MIN_REC=$($GET_CL_USERS |
+               awk 'min == "" || $2 < min {min = $2}; END {print min}')
+       FIRST_REC=$($LFS changelog $MDT0 | head -1 | awk '{print $1}')
+       echo "verifying min purge: $(( $MIN_REC + 1 )) == $FIRST_REC"
+       [ $FIRST_REC == $(($MIN_REC + 1)) ] ||
+               err17935 "first index should be $(($MIN_REC + 1)) is $FIRST_REC"
+
+       # LU-3446 changelog index reset on MDT restart
+       local MDT_DEV=$(mdsdevname ${SINGLEMDS//mds/})
+       CUR_REC1=$($GET_CL_USERS | head -1 | cut -f3 -d' ')
+       $LFS changelog_clear $MDT0 $USER 0
+       stop $SINGLEMDS || error "Fail to stop MDT."
+       start $SINGLEMDS $MDT_DEV $MDS_MOUNT_OPTS || error "Fail to start MDT."
+       CUR_REC2=$($GET_CL_USERS | head -1 | cut -f3 -d' ')
+       echo "verifying index survives MDT restart: $CUR_REC1 == $CUR_REC2"
+       [ $CUR_REC1 == $CUR_REC2 ] ||
+               err17935 "current index should be $CUR_REC1 is $CUR_REC2"
+
+       echo "verifying user deregister"
+       do_facet $SINGLEMDS $LCTL --device $MDT0 changelog_deregister $USER
+       $GET_CL_USERS | grep -q $USER &&
+               error "User $USER still in changelog_users"
+
+       USERS=$(( $($GET_CL_USERS | wc -l) - 2 ))
+       if [ $USERS -eq 0 ]; then
+               LAST_REC1=$($GET_CL_USERS | head -1 | cut -f3 -d' ')
+               touch $DIR/$tdir/chloe
+               LAST_REC2=$($GET_CL_USERS | head -1 | cut -f3 -d' ')
+               echo "verify changelogs are off: $LAST_REC1 == $LAST_REC2"
+               [ $LAST_REC1 == $LAST_REC2 ] || error "changelogs not off"
+       else
+               echo "$USERS other changelog users; can't verify off"
+       fi
 }
 run_test 160 "changelog sanity"
 
@@ -9456,9 +9598,10 @@ cleanup_obdecho_osc () {
         return 0
 }
 
-obdecho_create_test() {
+obdecho_test() {
         local OBD=$1
         local node=$2
+       local pages=${3:-64}
         local rc=0
         local id
         do_facet $node "$LCTL attach echo_client ec ec_uuid" || rc=1
@@ -9469,9 +9612,13 @@ obdecho_create_test() {
             [ ${PIPESTATUS[0]} -eq 0 -a -n "$id" ] || rc=3
         fi
         echo "New object id is $id"
-        [ $rc -eq 0 ] && { do_facet $node "$LCTL --device ec test_brw 10 w v 64 $id" ||
-                           rc=4; }
-        [ $rc -eq 0 -o $rc -gt 2 ] && { do_facet $node "$LCTL --device ec "    \
+       [ $rc -eq 0 ] && { do_facet $node "$LCTL --device ec getattr $id" ||
+                          rc=4; }
+       [ $rc -eq 0 ] && { do_facet $node "$LCTL --device ec "                 \
+                          "test_brw 10 w v $pages $id" || rc=4; }
+       [ $rc -eq 0 ] && { do_facet $node "$LCTL --device ec destroy $id 1" ||
+                          rc=4; }
+       [ $rc -eq 0 -o $rc -gt 2 ] && { do_facet $node "$LCTL --device ec "    \
                                         "cleanup" || rc=5; }
         [ $rc -eq 0 -o $rc -gt 1 ] && { do_facet $node "$LCTL --device ec "    \
                                         "detach" || rc=6; }
@@ -9481,46 +9628,72 @@ obdecho_create_test() {
 
 test_180a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-        remote_ost_nodsh && skip "remote OST with nodsh" && return
-        local rc=0
-        local rmmod_local=0
+       remote_ost_nodsh && skip "remote OST with nodsh" && return
+       local rc=0
+       local rmmod_local=0
 
-        if ! module_loaded obdecho; then
-            load_module obdecho/obdecho
-            rmmod_local=1
-        fi
+       if ! module_loaded obdecho; then
+           load_module obdecho/obdecho
+           rmmod_local=1
+       fi
 
-        local osc=$($LCTL dl | grep -v mdt | awk '$3 == "osc" {print $4; exit}')
-        local host=$(lctl get_param -n osc.$osc.import |
-                             awk '/current_connection:/ {print $2}' )
-        local target=$(lctl get_param -n osc.$osc.import |
-                             awk '/target:/ {print $2}' )
-        target=${target%_UUID}
-
-        [[ -n $target ]]  && { setup_obdecho_osc $host $target || rc=1; } || rc=1
-        [ $rc -eq 0 ] && { obdecho_create_test ${target}_osc client || rc=2; }
-        [[ -n $target ]] && cleanup_obdecho_osc $target
-        [ $rmmod_local -eq 1 ] && rmmod obdecho
-        return $rc
+       local osc=$($LCTL dl | grep -v mdt | awk '$3 == "osc" {print $4; exit}')
+       local host=$(lctl get_param -n osc.$osc.import |
+                            awk '/current_connection:/ {print $2}' )
+       local target=$(lctl get_param -n osc.$osc.import |
+                            awk '/target:/ {print $2}' )
+       target=${target%_UUID}
+
+       [[ -n $target ]]  && { setup_obdecho_osc $host $target || rc=1; } || rc=1
+       [ $rc -eq 0 ] && { obdecho_test ${target}_osc client || rc=2; }
+       [[ -n $target ]] && cleanup_obdecho_osc $target
+       [ $rmmod_local -eq 1 ] && rmmod obdecho
+       return $rc
 }
 run_test 180a "test obdecho on osc"
 
 test_180b() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-        remote_ost_nodsh && skip "remote OST with nodsh" && return
-        local rc=0
-        local rmmod_remote=0
-
-        do_facet ost1 "lsmod | grep -q obdecho || "                      \
-                      "{ insmod ${LUSTRE}/obdecho/obdecho.ko || "        \
-                      "modprobe obdecho; }" && rmmod_remote=1
-        target=$(do_facet ost1 $LCTL dl | awk '/obdfilter/ {print $4;exit}')
-        [[ -n $target ]] && { obdecho_create_test $target ost1 || rc=1; }
-        [ $rmmod_remote -eq 1 ] && do_facet ost1 "rmmod obdecho"
-        return $rc
+       remote_ost_nodsh && skip "remote OST with nodsh" && return
+       local rc=0
+       local rmmod_remote=0
+
+       do_facet ost1 "lsmod | grep -q obdecho || "                      \
+                     "{ insmod ${LUSTRE}/obdecho/obdecho.ko || "        \
+                     "modprobe obdecho; }" && rmmod_remote=1
+       target=$(do_facet ost1 $LCTL dl | awk '/obdfilter/ {print $4;exit}')
+       [[ -n $target ]] && { obdecho_test $target ost1 || rc=1; }
+       [ $rmmod_remote -eq 1 ] && do_facet ost1 "rmmod obdecho"
+       return $rc
 }
 run_test 180b "test obdecho directly on obdfilter"
 
+test_180c() { # LU-2598
+       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.4.0) ]] &&
+               skip "Need MDS version at least 2.4.0" && return
+
+       local rc=0
+       local rmmod_remote=false
+       local pages=16384 # 64MB bulk I/O RPC size
+       local target
+
+       do_rpc_nodes $(facet_active_host ost1) load_module obdecho/obdecho &&
+               rmmod_remote=true || error "failed to load module obdecho"
+
+       target=$(do_facet ost1 $LCTL dl | awk '/obdfilter/ {print $4}'|head -1)
+       if [[ -n $target ]]; then
+               obdecho_test "$target" ost1 "$pages" ||
+                       rc=${PIPESTATUS[0]}
+       else
+               echo "there is no obdfilter target on ost1"
+               rc=2
+       fi
+       $rmmod_remote && do_facet ost1 "rmmod obdecho" || true
+       return $rc
+}
+run_test 180c "test huge bulk I/O size on obdfilter, don't LASSERT"
+
 test_181() { # bug 22177
        test_mkdir -p $DIR/$tdir || error "creating dir $DIR/$tdir"
        # create enough files to index the directory
@@ -9568,6 +9741,9 @@ test_182() {
 run_test 182 "Disable MDC RPCs semaphore wouldn't crash client ================"
 
 test_183() { # LU-2275
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.3.56) ]] &&
+               skip "Need MDS version at least 2.3.56" && return
+
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        mkdir -p $DIR/$tdir || error "creating dir $DIR/$tdir"
        echo aaa > $DIR/$tdir/$tfile
@@ -9695,7 +9871,42 @@ test_184c() {
 }
 run_test 184c "Concurrent write and layout swap"
 
+test_184d() {
+       check_swap_layouts_support && return 0
+
+       local file1=$DIR/$tdir/$tfile-1
+       local file2=$DIR/$tdir/$tfile-2
+       local file3=$DIR/$tdir/$tfile-3
+       local lovea1
+       local lovea2
+
+       mkdir -p $DIR/$tdir
+       touch $file1 || error "create $file1 failed"
+       $OPENFILE -f O_CREAT:O_LOV_DELAY_CREATE $file2 ||
+               error "create $file2 failed"
+       $OPENFILE -f O_CREAT:O_LOV_DELAY_CREATE $file3 ||
+               error "create $file3 failed"
+       lovea1=$($LFS getstripe $file1 | sed 1d)
+
+       $LFS swap_layouts $file2 $file3 ||
+               error "swap $file2 $file3 layouts failed"
+       $LFS swap_layouts $file1 $file2 ||
+               error "swap $file1 $file2 layouts failed"
+
+       lovea2=$($LFS getstripe $file2 | sed 1d)
+       [ "$lovea1" == "$lovea2" ] || error "lovea $lovea1 != $lovea2"
+
+       lovea1=$(getfattr -n trusted.lov $file1 | grep ^trusted)
+       [ -z $lovea1 ] || error "$file1 shouldn't have lovea"
+}
+run_test 184d "allow stripeless layouts swap"
+
+
 test_185() { # LU-2441
+       # LU-3553 - no volatile file support in old servers
+       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.60) ]] ||
+               { skip "Need MDS version at least 2.3.60"; return 0; }
+
        mkdir -p $DIR/$tdir || error "creating dir $DIR/$tdir"
        touch $DIR/$tdir/spoo
        local mtime1=$(stat -c "%Y" $DIR/$tdir)
@@ -9725,6 +9936,37 @@ test_185() { # LU-2441
 }
 run_test 185 "Volatile file support"
 
+test_187a() {
+       local dir0=$DIR/$tdir/$testnum
+       mkdir -p $dir0 || error "creating dir $dir0"
+
+       local file=$dir0/file1
+       dd if=/dev/urandom of=$file count=10 bs=1M conv=fsync
+       local dv1=$($LFS data_version $file)
+       dd if=/dev/urandom of=$file seek=10 count=1 bs=1M conv=fsync
+       local dv2=$($LFS data_version $file)
+       [[ $dv1 != $dv2 ]] ||
+               error "data version did not change on write $dv1 == $dv2"
+
+       # clean up
+       rm -f $file1
+}
+run_test 187a "Test data version change"
+
+test_187b() {
+       local dir0=$DIR/$tdir/$testnum
+       mkdir -p $dir0 || error "creating dir $dir0"
+
+       declare -a DV=$($MULTIOP $dir0 Vw1000xYw1000xY | cut -f3 -d" ")
+       [[ ${DV[0]} != ${DV[1]} ]] ||
+               error "data version did not change on write"\
+                     " ${DV[0]} == ${DV[1]}"
+
+       # clean up
+       rm -f $file1
+}
+run_test 187b "Test data version change on volatile file"
+
 # OST pools tests
 check_file_in_pool()
 {
@@ -10286,6 +10528,57 @@ test_207b() {
 }
 run_test 207b "can refresh layout at open"
 
+test_208() {
+       # FIXME: in this test suite, only RD lease is used. This is okay
+       # for now as only exclusive open is supported. After generic lease
+       # is done, this test suite should be revised. - Jinshan
+
+       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.4.52) ]] ||
+               { skip "Need MDS version at least 2.4.52"; return 0; }
+
+       echo "==== test 1: verify get lease work"
+       $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:eRE+eU || error "get lease error"
+
+       echo "==== test 2: verify lease can be broken by upcoming open"
+       $MULTIOP $DIR/$tfile oO_RDONLY:eR_E-eUc &
+       local PID=$!
+       sleep 1
+
+       $MULTIOP $DIR/$tfile oO_RDONLY:c
+       kill -USR1 $PID && wait $PID || error "break lease error"
+
+       echo "==== test 3: verify lease can't be granted if an open already exists"
+       $MULTIOP $DIR/$tfile oO_RDONLY:_c &
+       local PID=$!
+       sleep 1
+
+       $MULTIOP $DIR/$tfile oO_RDONLY:eReUc && error "apply lease should fail"
+       kill -USR1 $PID && wait $PID || error "open file error"
+
+       echo "==== test 4: lease can sustain over recovery"
+       $MULTIOP $DIR/$tfile oO_RDONLY:eR_E+eUc &
+       PID=$!
+       sleep 1
+
+       fail mds1
+
+       kill -USR1 $PID && wait $PID || error "lease broken over recovery"
+
+       echo "==== test 5: lease broken can't be regained by replay"
+       $MULTIOP $DIR/$tfile oO_RDONLY:eR_E-eUc &
+       PID=$!
+       sleep 1
+
+       # open file to break lease and then recovery
+       $MULTIOP $DIR/$tfile oO_RDWR:c || error "open file error"
+       fail mds1
+
+       kill -USR1 $PID && wait $PID || error "lease not broken over recovery"
+
+       rm -f $DIR/$tfile
+}
+run_test 208 "Exclusive open"
+
 test_212() {
        size=`date +%s`
        size=$((size % 8192 + 1))
@@ -10386,12 +10679,13 @@ test_215() { # for bugs 18102, 21079, 21517
 
        # /proc/sys/lnet/routes should look like this:
        # Routing disabled/enabled
-       # net hops state router
-       # where net is a string like tcp0, hops >= 0, state is up/down,
+       # net hops priority state router
+       # where net is a string like tcp0, hops > 0, priority >= 0,
+       # state is up/down,
        # router is a string like 192.168.1.1@tcp2
        L1="^Routing (disabled|enabled)$"
-       L2="^net +hops +state +router$"
-       BR="^$NET +$N +(up|down) +$NID$"
+       L2="^net +hops +priority +state +router$"
+       BR="^$NET +$N +(0|1) +(up|down) +$NID$"
        create_lnet_proc_files "routes"
        check_lnet_proc_entry "routes.out" "/proc/sys/lnet/routes" "$BR" "$L1" "$L2"
        check_lnet_proc_entry "routes.sys" "lnet.routes" "$BR" "$L1" "$L2"
@@ -10451,16 +10745,20 @@ run_test 215 "/proc/sys/lnet exists and has proper content - bugs 18102, 21079,
 
 test_216() { # bug 20317
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-        remote_ost_nodsh && skip "remote OST with nodsh" && return
-        local node
-        local p="$TMP/sanityN-$TESTNAME.parameters"
-        save_lustre_params $HOSTNAME "osc.*.contention_seconds" > $p
-        for node in $(osts_nodes); do
-                save_lustre_params $node "ldlm.namespaces.filter-*.max_nolock_bytes" >> $p
-                save_lustre_params $node "ldlm.namespaces.filter-*.contended_locks" >> $p
-                save_lustre_params $node "ldlm.namespaces.filter-*.contention_seconds" >> $p
-        done
-        clear_osc_stats
+       remote_ost_nodsh && skip "remote OST with nodsh" && return
+
+       local node
+       local facets=$(get_facets OST)
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+
+       save_lustre_params client "osc.*.contention_seconds" > $p
+       save_lustre_params $facets \
+               "ldlm.namespaces.filter-*.max_nolock_bytes" >> $p
+       save_lustre_params $facets \
+               "ldlm.namespaces.filter-*.contended_locks" >> $p
+       save_lustre_params $facets \
+               "ldlm.namespaces.filter-*.contention_seconds" >> $p
+       clear_osc_stats
 
         # agressive lockless i/o settings
         for node in $(osts_nodes); do
@@ -10950,6 +11248,50 @@ test_228c() {
 }
 run_test 228c "NOT shrink the last entry in OI index node to recycle idle leaf"
 
+test_229() { # LU-2482, LU-3448
+       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       [ $OSTCOUNT -lt 2 ] && skip "needs >= 2 OSTs" && return
+
+       rm -f $DIR/$tfile
+
+       # Create a file with a released layout and stripe count 2.
+       $MULTIOP $DIR/$tfile H2c ||
+               error "failed to create file with released layout"
+
+       $GETSTRIPE -v $DIR/$tfile
+
+       local pattern=$($GETSTRIPE -v $DIR/$tfile |
+                       grep lmm_stripe_pattern | awk '{print $2}')
+       [ X"$pattern" = X"80000001" ] || error "pattern error ($pattern)"
+
+       local stripe_count=$($GETSTRIPE -c $DIR/$tfile) || error "getstripe"
+       [ $stripe_count -eq 2 ] || error "stripe count not 2 ($stripe_count)"
+       stat $DIR/$tfile || error "failed to stat released file"
+
+       $TRUNCATE $DIR/$tfile 200000 &&
+               error "truncate of released file should fail"
+
+       # Ensure that nothing happened anyway.
+       $CHECKSTAT -s 0 $DIR/$tfile ||
+               error "released file size should not change"
+
+       # Stripe count should be no change after truncate
+       stripe_count=$($GETSTRIPE -c $DIR/$tfile) || error "getstripe failed"
+       [ $stripe_count -eq 2 ] || error "after trunc: ($stripe_count)"
+
+       chown $RUNAS_ID $DIR/$tfile ||
+               error "chown $RUNAS_ID $DIR/$tfile failed"
+
+       chgrp $RUNAS_ID $DIR/$tfile ||
+               error "chgrp $RUNAS_ID $DIR/$tfile failed"
+
+       touch $DIR/$tfile ||
+               error "touch $DIR/$tfile failed"
+
+       rm $DIR/$tfile || error "failed to remove released file"
+}
+run_test 229 "getstripe/stat/rm/attr changes work on released files"
+
 test_230a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
@@ -11076,6 +11418,36 @@ test_232() {
 }
 run_test 232 "failed lock should not block umount"
 
+test_233() {
+       local fid=$($LFS path2fid $MOUNT)
+       stat $MOUNT/.lustre/fid/$fid > /dev/null ||
+               error "cannot access $MOUNT using its FID '$fid'"
+}
+run_test 233 "checking that OBF of the FS root succeeds"
+
+test_234() {
+       local p="$TMP/sanityN-$TESTNAME.parameters"
+       save_lustre_params client "llite.*.xattr_cache" > $p
+       lctl set_param llite.*.xattr_cache 1 ||
+               { skip "xattr cache is not supported"; return 0; }
+
+       mkdir -p $DIR/$tdir || error "mkdir failed"
+       touch $DIR/$tdir/$tfile || error "touch failed"
+       # OBD_FAIL_LLITE_XATTR_ENOMEM
+       $LCTL set_param fail_loc=0x1405
+       setfattr -n user.attr -v value $DIR/$tdir/$tfile &&
+               error "setfattr should have failed with ENOMEM"
+       # attr pre-2.4.44-7 had a bug with rc
+       getfattr -n user.attr $DIR/$tdir/$tfile &&
+               error "getfattr should have failed with ENOMEM"
+       $LCTL set_param fail_loc=0x0
+       rm -rf $DIR/$tdir
+
+       restore_lustre_params < $p
+       rm -f $p
+}
+run_test 234 "xattr cache should not crash on ENOMEM"
+
 #
 # tests that do cleanup/setup should be run at the end
 #